//===========================================================================
//  
// (C)ͪϼᶡ1996/8/1 1997/5/5
//===========================================================================
#include  <stdio.h>
#include  "dscope.h"
#include  <owl/window.h>
#include  <math.h>
#include  <dir.h>
#include  <time.h>
//----------------------------------
#define TimerID 1
extern  int ArgC;
extern  char  **ArgV;
//char  fname[MAXPATH];
//FILE  *fp = 0;
Profile pro;
char  iFile[MAXPATH] = "gidadc.ini";

// 0̸ , 1̸ , 2̸ 
int Ach[8] = {0,0,0,0,0,0,0,0};
unsigned int Tint=100;  //
time_t  Tfile=0;      //ϰ
int buf[2048];    // 
int FirstStart;
FFT   fft(10);
int   FFTMode;
//----------------------------------
DSCOPE::DSCOPE(TWindow *parent, const char *title)
 : TFrameWindow(parent, title)
{
}
//----------------------------------
DSCOPE::~DSCOPE(void)
{
  KillTimer(TimerID);
}
//----------------------------------
void  DSCOPE::SetupWindow(void)
{
  int comport,  ClkWait,  tmp;

  SetIcon(GetModule(),  ICON_1);
  Attr.H = 200;
  Attr.W = 400;

  if(ArgC>1)  strcpy(iFile, ArgV[ArgC]);
  pro.ProfileOpen(iFile);
  comport = pro.GetInt("GidADC", "ComPort", -1);
  ClkWait = pro.GetInt("GidADC", "ClkWait", -1);

  if(comport < 0 || ClkWait < 0)  {
    MessageBox("ĿƮ DIR gidini.exe ⵿ϰ \n ʱȭ (gidadc.ini)\n
 ۼϿ ֽʽÿ",
                "ʱȭ   ʽϴ");
    exit(EXIT_FAILURE);
  }

  InCh = pro.GetInt("Dscope", "InCh", 0);
  Freeze = 0;
  FirstStart=1;
  FMode = FFTMode = pro.GetInt("Dscope", "FFTMode", 0);
  switch(pro.GetInt("Dscope", "FFTMask", 0)) {
  case  fft.MDoNothing: CM_FNone(); break;
  case  fft.MTriangle:  CM_FTri(); break;
  case  fft.MSine:      CM_FSin(); break;
  case  fft.MHunning:   CM_FHun(); break;
  case  fft.MHumming:   CM_FHum(); break;
  default : break;
  }
  LineMode = pro.GetInt("Dscope", "LineMode", 0);
  ADC.InitPower(comport);
  tmp = pro.GetInt("Dscope", "ClkWait", -1);
  if(tmp>0) ClkWait = tmp;
  ADC.SetClkWait(ClkWait);
  ADC.SetCh(InCh);       // AD-Input ch
  ADC.SetBipola();
  ADC.SetTrigaAuto();
  ADC.SetCliMode();

  SetTimer(TimerID, 100); //ID=1 time=Xmsec
}
//----------------------------------
void  DSCOPE::EvTimer(uint) {  AdcRun();  }
//----------------------------------
//----------------------------------
void  DSCOPE::AdcRun(void)
{
  int n;
  if(FirstStart)  {
    CM_TAdj();
/*
    TRect tr = GetClientRect();
    TClientDC dc(HWindow);
    DrawStr1(dc, "Start! H-Time Span Test ...........");
    SetXDataTime(ADC.GetNCnvTime()*1000.0);  // ȯ ð
*/
    FirstStart=0;
  }
  if(Freeze==0) {
    ADC.SetCh(InCh);       // ch Set
    if((n=GetXDataSize())>1024) n=1024;
     TRect tr = GetClientRect();
      TClientDC dc(HWindow);
      if(FFTMode) {
      ADC.GetNTCnv(0,  1024,  2, buf);
      fft.SetIntData(buf);
      fft.MaskExe();
         fft.fft_cnv();
      fft.Kikaku();
/*
      fft.GetIntData(buf);
      for(n=0; n<1024; n++) buf[n] -= 4*GetYDiv();
*/
      fft.GetDBCnv(buf, GetYDiv(), 1000);
         Flush(tr, dc, buf);
    } else {
      if(ADC.GetNTCnv(0,  n,  2, buf) == 0)  {
            Flush(tr, dc, buf);
         }
    }
  }
  KillTimer(TimerID);
  SetTimer(TimerID, 500); //ID=1 time=Xmsec
}
//----------------------------------
//ǥϴ ڿ  20 ̳

char  *DSCOPE::DStrForm(int d, char *cp)
{
  if(FFTMode) {
//    double  xd = XDotData/(XDataTime * XDotDiv);

    double  xd = 1000.0*XDotDiv/(XDataTime * XDotData*1024);
    sprintf(cp, " CH%1d %4.1fHz/div 10dBV/div Max%3.1fdBV FFT1k      ",
              d, xd, MaxD/50.0-20-fdif);
  } else  {
    return  Scope::DStrForm(d, cp);
  }
  return  cp;
}
//----------------------------------
void DSCOPE::RePaint(void)
{
  TRect tr = GetClientRect();
  TClientDC dc(HWindow);
  ReDraw(dc, tr);
}
//----------------------------------
void DSCOPE::Paint(TDC& , bool , TRect& )
{
  RePaint();
}
//----------------------------------
void  DSCOPE::EvSize(UINT, TSize &)
{
  RePaint();
}
//----------------------------------
void  DSCOPE::CM_TrigP(void){  ADC.SetTrigaAuto();  ADC.SetTrigaPlus();  }
//----------------------------------
void  DSCOPE::CM_TrigM(void){  ADC.SetTrigaAuto();  ADC.SetTrigaMinus();  }
//----------------------------------
void  DSCOPE::CM_TrigNone(void){  ADC.SetTrigaNone();  }
//----------------------------------
void  DSCOPE::CM_InCh0(void) {
  SetInCh(InCh = 0);  pro.SetInt("DSCOPE", "InCh", InCh); RePaint();}
void  DSCOPE::CM_InCh1(void) {
  SetInCh(InCh = 1);  pro.SetInt("DSCOPE", "InCh", InCh); RePaint();}
void  DSCOPE::CM_InCh2(void) {
  SetInCh(InCh = 2);  pro.SetInt("DSCOPE", "InCh", InCh); RePaint();}
void  DSCOPE::CM_InCh3(void) {
  SetInCh(InCh = 3);  pro.SetInt("DSCOPE", "InCh", InCh); RePaint();}
void  DSCOPE::CM_InCh4(void) {
  SetInCh(InCh = 4);  pro.SetInt("DSCOPE", "InCh", InCh); RePaint();}
void  DSCOPE::CM_InCh5(void) {
  SetInCh(InCh = 5);  pro.SetInt("DSCOPE", "InCh", InCh); RePaint();}
void  DSCOPE::CM_InCh6(void) {
  SetInCh(InCh = 6);  pro.SetInt("DSCOPE", "InCh", InCh); RePaint();}
void  DSCOPE::CM_InCh7(void) {
  SetInCh(InCh = 7);  pro.SetInt("DSCOPE", "InCh", InCh); RePaint();}
//----------------------------------
void  DSCOPE::CM_YDiv4000(void) {
  fdif = 20.0;  SetYDiv(1000); ADC.SetUnipola(); RePaint();}
void  DSCOPE::CM_YDiv1000(void) {
  fdif = 20.0;  SetYDiv(1000);  ADC.SetBipola();  RePaint();}
void  DSCOPE::CM_YDiv500(void) {
  fdif = 0.0;  SetYDiv(500);  ADC.SetBipola();  RePaint();}
void  DSCOPE::CM_YDiv200(void) {
  fdif = -12.0;  SetYDiv(200); ADC.SetBipola();  RePaint(); }
void  DSCOPE::CM_YDiv100(void) {
  fdif = -16.0;  SetYDiv(100);  ADC.SetBipola();  RePaint();}
void  DSCOPE::CM_YDiv50(void) {
  fdif = -18.0;  SetYDiv(50);  ADC.SetBipola();  RePaint();}
void  DSCOPE::CM_YDiv20(void) {
  fdif = -19.2;  SetYDiv(20);  ADC.SetBipola();  RePaint();}
//----------------------------------
void  DSCOPE::CM_LineMode(void) {
  SetLineMode(); pro.SetInt("DSCOPE", "LineMode", LineMode); RePaint();  }
//----------------------------------
void  DSCOPE::CM_Freeze(void) { Freeze = ~Freeze;  CMode = 0; RePaint(); }
//----------------------------------
void  DSCOPE::CM_TAdj(void)
{
  double  TAdj;
  TAdj = pro.GetDbl("DSCOPE", "TADJ", 0.9);

  TRect tr = GetClientRect();
  TClientDC dc(HWindow);
  DrawStr1(dc, "Start! H-Time Span Test ...........");
  SetXDataTime(TAdj*ADC.GetNCnvTime()*1000.0);  // ȯ ð
}
//----------------------------------
void  DSCOPE::CM_High(void) { if(XDotData<32)  XDotData *= 2; RePaint();  }
void  DSCOPE::CM_Low(void)  { if(XDotData>1)  XDotData /= 2;  RePaint();  }
//----------------------------------
void  DSCOPE::CM_Fft(void)  {
  FMode = FFTMode = !FFTMode; pro.SetInt("Dscope", "FFTMode", FFTMode);
  RePaint();
}
//----------------------------------
void  DSCOPE::CM_FNone(void)   {
  fft.DoNothing();  pro.SetInt("Dscope", "FFTMask", fft.MDoNothing); }
void  DSCOPE::CM_FTri(void) {
  fft.Triangle();   pro.SetInt("Dscope", "FFTMask", fft.MTriangle); }
void  DSCOPE::CM_FSin(void) {
  fft.Sine(); pro.SetInt("Dscope", "FFTMask", fft.MSine); }
void  DSCOPE::CM_FHun(void) {
  fft.Hunning(); pro.SetInt("Dscope", "FFTMask", fft.MHunning); }
void  DSCOPE::CM_FHum(void) {
  fft.Humming(); pro.SetInt("Dscope", "FFTMask", fft.MHumming); }
//----------------------------------
void  DSCOPE::CM_Ver(void)
{
  TDialog *ver = new TDialog(this, DIALOG_VER);
  ver->Execute();
}
//----------------------------------
// ϰ ִٸ   
void  DSCOPE::EvLButtonDown(uint , TPoint& )
{
  if(Freeze)  {
    CMode = 1;
    CrosMode=0;
  } else  CM_Freeze();
}
//----------------------------------
// ϰ ִٸ Ѵ
void  DSCOPE::EvLButtonDblClk(uint , TPoint& )
{
  if(Freeze)  CM_Freeze();
}
//----------------------------------
// ϰ ִٸ ȭ鿡 ͸ 
void  DSCOPE::EvMouseMove(uint /*modKeys*/, TPoint& point)
{
  if(Freeze)  {
    TClientDC dc(HWindow);
    DrawCross1(dc, point, CMode);
  }
}
//----------------------------------
DEFINE_RESPONSE_TABLE1(DSCOPE, TWindow)
  EV_WM_TIMER,
  EV_WM_SIZE,
  EV_WM_MOUSEMOVE,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONDBLCLK,
  EV_COMMAND(CM_TRIGP, CM_TrigP),
  EV_COMMAND(CM_TRIGM, CM_TrigM),
  EV_COMMAND(CM_TRIGN, CM_TrigNone),
  EV_COMMAND(CM_INCH0, CM_InCh0),
  EV_COMMAND(CM_INCH1, CM_InCh1),
  EV_COMMAND(CM_INCH2, CM_InCh2),
  EV_COMMAND(CM_INCH3, CM_InCh3),
  EV_COMMAND(CM_INCH4, CM_InCh4),
  EV_COMMAND(CM_INCH5, CM_InCh5),
  EV_COMMAND(CM_INCH6, CM_InCh6),
  EV_COMMAND(CM_INCH7, CM_InCh7),

  EV_COMMAND(CM_YDIV4,    CM_YDiv4000),
  EV_COMMAND(CM_YDIV1000, CM_YDiv1000),
  EV_COMMAND(CM_YDIV500,  CM_YDiv500),
  EV_COMMAND(CM_YDIV200,  CM_YDiv200),
  EV_COMMAND(CM_YDIV100,  CM_YDiv100),
  EV_COMMAND(CM_YDIV50,   CM_YDiv50),
  EV_COMMAND(CM_YDIV20,   CM_YDiv20),

  EV_COMMAND(CM_LINEMODE, CM_LineMode),
//  EV_COMMAND(CM_DCAC,     CM_DcAc),
  EV_COMMAND(CM_FREEZE,   CM_Freeze),

  EV_COMMAND(CM_TADJ,     CM_TAdj),

  EV_COMMAND(CM_HIGH,     CM_High),
  EV_COMMAND(CM_LOW,      CM_Low),

  EV_COMMAND(CM_FFT,      CM_Fft),
  EV_COMMAND(CM_FFTMASK_NONE,      CM_FNone),
  EV_COMMAND(CM_FFTMASK_TRI,      CM_FTri),
  EV_COMMAND(CM_FFTMASK_SIN,      CM_FSin),
  EV_COMMAND(CM_FFTMASK_HUN,      CM_FHun),
  EV_COMMAND(CM_FFTMASK_HUM,      CM_FHum),

  EV_COMMAND(CM_VER,      CM_Ver),

END_RESPONSE_TABLE;
//----------------------------------
