/*===============================================*/
/* PC ȭ ܺ ̽                      */
/* GUPPY  interface                                */
/* (C)Mathematical Assist Design Lab.1996/8/1    */
/* IBM-PC, PC-98    SW                   */
/* BC MSCϷ  SW                      */
/*===============================================*/
/*ӽ  ӣ */
/* #define PCAT
   #define PC98 */
#define PCAT
/*===============================================*/
/*Ϸ  ӣ */
#define BC
/* #define MSC */
/*===============================================*/
/* IBM-PC ϵ */
#ifdef PCAT
  #define COM1_BASE     0x3f8
  #define COM2_BASE     0x2f8
  #define COM3_BASE     0x3e8
  #define COM4_BASE     0x2e8
  #define SIO_MDM       4       /* rw modem control */
  #define SIO_MDM_RTS   0x02    /* RTS */
  #define SIO_MDM_DTR   0x01    /* DTR */
  #define SIO_MSR       6       /* rw modem status */
  #define SIO_MDMS_RLSD 0x80    /* RLSD */
  #define SIO_LCR       3       /* rw line contorlo */
  #define SIO_BRK       0x40    /*  break data send                  */
#endif /* PCAT */
/*------------------------*/
#ifdef  PC98
  #define SIO_RES 0x40          /*  Ŀǵ */
  #define SIO_8N 0x4e     /* 8bit non parity 16clk */

  /* 8251 command */
  #define SIO_TX_EN 0x01    /*  0=۽ 1=۽㰡                */
  #define SIO_DTR   0x02    /*   ģԣ                        */
  #define SIO_RX_EN 0x04    /*  0=ű 1=㰡                */
  #define SIO_BRK   0x08    /*  0=  1=극ũ(۽Ż£)     */
  #define SIO_ECL   0x10    /*  0=nop 1= ÷ Ŭ           */
  #define SIO_RTS   0x20    /*   ңԣ                        */
  #define SIO_SRES  0x40    /*  0=nop 1=                         */
  #define SIO_EH    0x80    /*  0=nop 1=ڵ         */

  /* 8251 status  */
  #define SIO_TX_RDY   0x01    /*  0=۽ Ǯ  1=                */
  #define SIO_RX_RDY   0x02    /*  0=   1=  */
  #define SIO_TX_EMP   0x04    /*  0=۽   1=۽ ƴ */
  #define SIO_PE       0x08    /*  0=иƼ   1=            */
  #define SIO_OVE      0x10    /*  0=   1=            */
  #define SIO_FE       0x20    /*  0=÷   1=            */
  #define SIO_SYNC_BRK 0x40    /*  0/1=극ũ                     */
  #define SIO_DSR      0x80    /*   ģӣ                  */

  /*; 8251a 2-12-1*/
  #define SIOD 0x30
  #define SIOC 0x32
  #define PPI1B 0x33        /*
  ;   pb0   calender read line
  ;   pb1   external ram parity error detecter
  ;   pb2   none
  ;   pb3   crt type 1=high, 0=normal
  ;   pb4   int3(HD)
  ;   pb5   CD carrier detect(negative)
  ;   pb6   CTS (negative)
  ;   pb7   CI (rs232c ?) */
  #define DSR_MASK 0x10  /* 8251 MSB   ´ */
  #define CD_MASK 0x20
  #define CTS_MASK 0x40
  #define CI_MASK 0x80

#endif  /* for PC98 */
/*===============================================*/
#ifdef MSC
#define outportb  outp
#define inportb inp
#endif  /* for MSC */
/*===============================================*/
#include <dos.h>
int GbDOut(int Command);
void  GbSetComport(int  c);
/*===============================================*/
/* ޸  */
#ifdef  PCAT
  static  int GbComport;
#endif  /* PCAT */

#ifdef  PC98
  static  unsigned char ComMem;
#endif


#define UNIPOLA 0x08
#define BIPOLA  0
static  int GbPola;

static  int GbCh;

#define Diff  0
#define Singl 0x04
static  int GbSglDif;
static  int GbTrigaPola;   /* 1= , -1=翡  */
static  int GbTrigaAuto;   /* 1=Auto, else Normal */
static  long  GbTW;        /* ޽Ľð   */
static  int GbTxStat;      /* ԣ 극ũ  */
/*===============================================*/
void  GbInit(void)
{
#ifdef  PCAT
  GbComport = COM1_BASE;
#endif  /* PCAT */

  GbPola = BIPOLA;  GbCh = 0;  GbSglDif = Singl;
  GbTrigaPola = 1;  GbTrigaAuto = 1;  GbTW = 1;
}
/*--------------------------*/
// ϴ ãϣ Ʈȣ
#pragma argsused
void  GbInitPower(int  ComNum)
{
  long t;

#ifdef  PC98
  unsigned int tn;
  outportb(SIOC, 0);        for(tn=0xffff; tn>0; tn--);
  outportb(SIOC, 0);        for(tn=0xffff; tn>0; tn--);
  outportb(SIOC, SIO_RES);  for(tn=0xffff; tn>0; tn--);
  outportb(SIOC, SIO_8N);   for(tn=0xffff; tn>0; tn--);
  outportb(SIOC, ComMem = SIO_RTS | SIO_DTR);
#endif  /* PC98 */

#ifdef  PCAT
  GbSetComport(ComNum);
  outportb(GbComport + SIO_MDM, 0);
  outportb(GbComport + SIO_MDM, SIO_MDM_RTS | SIO_MDM_DTR);
#endif  /* PCAT */

  GbTxStat=0;
  for(t = 1000L;  t>0;  t--);   //  ٸ
  GbDOut(0x86);  // Ŭϸ 
}
/*--------------------------*/
/* ϴ ãϣ Ʈȣ */
#pragma argsused
void  GbSetComport(int  c)
{
#ifdef  PCAT
  switch(c) {
  case  1:  GbComport = COM1_BASE;  break;
  case  2:  GbComport = COM2_BASE;  break;
  case  3:  GbComport = COM3_BASE;  break;
  case  4:  GbComport = COM4_BASE;  break;
  default : break;
  }
#endif  /* PCAT */
}

/*--------------------------*/
void  GbSetCh(int  ch)
{
  static  int chn[8] = { 0x00, 0x40, 0x10, 0x50, 0x20, 0x60, 0x30, 0x70 };
  GbCh = chn[ch & 0x07];
}
/*--------------------------*/
void  GbSetUnipola(void)  { GbPola = UNIPOLA; }
void  GbSetBipola(void){ GbPola = BIPOLA;  }
void  GbSetSingle(void) { GbSglDif = Singl; }
void  GbSetDiff(void)   { GbSglDif = Diff; }
void  GbSetTrigaNone(void)  { GbTrigaPola = 0;  }
void  GbSetTrigaPlus(void)  { GbTrigaPola = 1;  }
void  GbSetTrigaMinus(void)  { GbTrigaPola = -1;  }
void  GbSetTWait(long t)  { GbTW = t;   if(GbTW <=0) GbTW=1;}
long  GbGetTWait(void)  { return  GbTW; }

/*-----------------------------------*/
/*long  GetTime55ms(void) { return  biostime(0, 0L);  }*/
/*-----------------------------------*/
/* 1Ŭ    */
int GbCnv(void)
{
  int m,  rd;
  m = 0x80 | GbCh | GbPola | GbSglDif | 0x01;

  rd = GbDOut(m);
  if(GbPola == BIPOLA)  { if(rd > 2047) rd = rd - 4096; }
  return  rd;
}
/*-----------------------------------*/
/*   ,Ʈ  ȸ ٸ   ش*/
#pragma argsused
int GbNTCnv(int v,  int  n,  int wn, int *buf, long *tbuf)
{
  int w;
  if(GbTrigaAuto && wn) w = n*2;  else  w = 10000;
  if(GbTrigaPola==1) {
    for(; GbCnv() > v && w > 0;  w--);    
    for(; GbCnv() < v && w > 0;  w--);
  } else  if(GbTrigaPola<1){
    for(; GbCnv() < v && w > 0;  w--);    
    for(; GbCnv() > v && w > 0;  w--);
  }
  if(w<=0 && !GbTrigaAuto)  return  1;

/*asm { pushf;   cli; }*/
  for(; n>0;  n--)  {
    *buf++ = GbCnv();   /* if(tbuf) *tbuf++ = GetTime55ms(); */
  }
/*asm { popf; } */

  return  0;
}
/*-----------------------------------*/
void  GbTWait(void)
{
  long n;
  for(n = GbTW; n>0;  n--);
}
/*-----------------------------------*/
int GbSCLK(int  Dout)
{
  int rd;

#ifdef  PCAT
  //data out
  outportb(GbComport + SIO_MDM, ((Dout)? 0 : SIO_MDM_RTS) | SIO_MDM_DTR);
  GbTWait();
  //data in
  rd = inportb(GbComport + SIO_MSR) & SIO_MDMS_RLSD;
  //sclk 1
  outportb(GbComport + SIO_MDM, ((Dout)? 0 : SIO_MDM_RTS));
  GbTWait();
  //sclk 0
  outportb(GbComport + SIO_MDM, SIO_MDM_RTS | SIO_MDM_DTR);
  GbTWait();
#endif

#ifdef  PC98
  //data out
  outportb(SIOC,  ((Dout)? 0 : SIO_RTS) | SIO_DTR);
  GbTWait();
  //data in
  rd = ~(inportb(PPI1B)) & CD_MASK;
  //sclk 1
  outportb(SIOC, ((Dout)? 0 : SIO_RTS));
  GbTWait();
  //sclk 0
  outportb(SIOC, SIO_RTS | SIO_DTR);
  GbTWait();
#endif
  return  rd;
}
/*-----------------------------------*/
/* ģÿ Ŀǵ  ¸ Ѵ */
void  GbSetTxE(void)
{
#ifdef  PCAT
  if(GbTxStat) {  outportb(GbComport + SIO_MDM, SIO_MDM_DTR);   /*RTS=0*/ }
  else  { outportb(GbComport+SIO_MDM, SIO_MDM_RTS | SIO_MDM_DTR); /*RTS=1*/ }
#endif  /* IBM-PC */

#ifdef  PC98
  outportb(SIOC, ComMem);
#endif
}
/*-----------------------------------*/
/*ģɣ ̳ʽ ϹǷ, ȯߵ £ɣϣӳο   
  i=0    i!=0 Tx=HiLEVEL
*/
void  GbSetTx(int i)
{
#ifdef  PCAT
  if(i) {
    outportb(GbComport + SIO_LCR, SIO_BRK);   //극ũ ȣ 
    outportb(GbComport + SIO_MDM, SIO_MDM_DTR);   //RTS=0
  } else  {
    outportb(GbComport + SIO_LCR, 0);
    outportb(GbComport + SIO_MDM, SIO_MDM_RTS | SIO_MDM_DTR);   //RTS=1
  }
#endif  /* IBM-PC */

#ifdef  PC98
  if(i) {
    ComMem = SIO_BRK | SIO_DTR; //극ũ ȣ 
  } else  {
    ComMem = SIO_DTR | SIO_RTS; //극ũ ȣ 
  }
  outportb(SIOC, ComMem);
#endif  /* PC98 */

  GbTxStat = i;
}
/*-----------------------------------*/
/*ð(У)ŭ ԣȣ  Ѵ */
void  GbSetTxPulse(long t)
{
  GbSetTx(1);
  for(; t>0;  t--);
  GbSetTx(0);
}
/*-----------------------------------*/
// Ǿ ִ Ƴα ä о鼭 data ʰϱ Tx 1
//Ѵ.  ʰϸ 0 ư. ó ͸ Ͽ ϹǷ
//޽  ʴ 쵵 ִ.
void  GbSetTxPulseWait(int d)
{
  if(d >= GbCnv())  {
    GbSetTx(1);
    while(d >= GbCnv());
    GbSetTx(0);
  }
}
/*-----------------------------------*/
int GbDOut(int Command)
{
  int n,  rd;

  /*Ŀǵ */
  for(n=8;  n>0;  n--)  { rd = GbSCLK(Command & 0x80);  Command <<= 1;  }
  //Get DATA
  for(rd=0,n=13;  n>0;  n--)
  { rd = (rd << 1) | (GbSCLK(0)? 1 : 0);  }

  //ԣ ¿  ¸ Ѵ(  )
  GbSetTxE();
  return  rd & 0xfff;
}
/*-----------------------------------*/
/*-----------------------------------*/

