/*

     ĳ ÷  α׷
    ̣ã Ʈѷȣģ(4bit access)

    data   = bit0-3
    enable = bit6
    RS     = bit7
*/
/* ̣ã Ʈѷ  ۿ   */
#define LCD_E0  0xbf        /*Ʈѷ enable=0*/
#define LCD_E1  0x40        /*               =1*/
#define LCD_CR  0x7f        /*Ŀǵ */
#define LCD_DR  0x80        /* */
/* ̣ã Ʈѷ Ŀǵ ǣȣģ*/
#define LCD_INIT1 0x03      /*             8bit  ʱȭ1*/
#define LCD_INIT2 0x02      /*             4bit  ʱȭ2*/
#define LCD_CLS   0x01      /*wait=1640uS  ȭҰ*/
#define LCD_HOME  0x02      /*     1640uS  Ŀ ο*/
#define LCD_ENTRY 0x06      /*       40uS  ֱ */
#define LCD_ON    0x0f      /*       40uS  ̣ã ǥ*/
#define LCD_OFF   0x08      /*       40uS  ̣ã ǥ*/
#define LCD_FUNC  0x28      /*       40uS  ǥü(4bit)*/

/* Լ Ÿ  */
void wait(void);
void dsend(void);

/* ̣ã ̳̺  */
void Eon(void)
{
    out1=out1 & LCD_E0;
    dsend();
}
void Eoff(void)
{
    out1=out1 | LCD_E1;
    dsend();
}
void CMDmod(void)
{
    out1=out1 & LCD_CR;
}
void DATmod(void)
{
    out1=out1 | LCD_DR;
}
/* ̣ã Ʈѷ Ŀǵ带 Ѵ */
void LCDcd2(unsigned char dat)
{
    out1=out1 & 0xf0;
    out1=out1 | (dat & 0x0f);
    CMDmod();
    Eoff();
    Eon();
}
void LCDcmd(unsigned char dat)
{
    /* 4bit */
    out1=out1 & 0xf0;
    out1=out1 | (dat >> 4);
    CMDmod();
    Eoff();
    Eon();
    /* 4bit */
    out1=out1 & 0xf0;
    out1=out1 | (dat & 0x0f);
    CMDmod();
    Eoff();
    Eon();
}
/* ̣ã Ʈѷ ͸ Ѵ */
void LCDdata(unsigned char dat)
{
    /* 4bit */
    out1=out1 & 0xf0;
    out1=out1 | (dat >> 4);
    DATmod();
    Eoff();
    Eon();
    /* 4bit */
    out1=out1 & 0xf0;
    out1=out1 | (dat & 0x0f);
    DATmod();
    Eoff();
    Eon();
}

/* Ʈ */
void waitn(unsigned int tm)
{
int i;
    for(;tm!=0;tm--) wait();
}

/* ̣ã ü ȭҰ */
void LCDclear(void)
{
    LCDcmd(LCD_CLS);
    waitn(1640);
}
/* Ŀ η ǵ */
void LCDhome(void)
{
    LCDcmd(LCD_HOME);
    waitn(1640);
}
/* ̣ã  ʱȭ */
void LCDinit(void)
{
    LCDcd2(LCD_INIT1);  /*8bit  Ŀǵ(dummy)*/
    LCDcd2(LCD_INIT1);  /*8bit  Ŀǵ(dummy)*/
    LCDcd2(LCD_INIT1);  /*8bit  Ŀǵ(dummy)*/
    LCDcd2(LCD_INIT2);  /*4bit  Ŀǵ*/
    LCDcmd(LCD_FUNC);   /*ɼ*/
//    waitn(40);        /*Ŀǵ  Ʈ ִ´*/
    LCDclear();         /*ȭҰ*/
    LCDhome();          /*Ŀ η ǵ*/
    LCDcmd(LCD_ON);     /*̣ã ǥ ϣ*/
//    waitn(40);
}
/* ̣ã ؽƮ ǥ */
void LCDputs(unsigned char *text)
{
    LCDcmd(LCD_ENTRY);      /*ֱ */
//    waitn(40);
    for(;*text!=0;text++) {
        LCDdata(*text);
//        waitn(40);
    }
}
/* ̣ã Ŀ ġ */
void LCDxy(int x,int y)
{
    if(y==1) LCDcmd(0x80+x-1);
    if(y==2) LCDcmd(0x80+0x40+x-1);
//    LCDcmd(LCD_ENTRY);      /*ֱ */
//    waitn(40);
}
