/*
** 74HC595 74HC597 
** øƮ ̿ з  Ʈѷ
**
**   øƮ ȣ
**    data_out   : DTR
**    data_in    : DSR
**    clock_cont : RTS
**    latch_cont : TXD
**
**    for BC++4.0J
**  PC98 : bcc /DPC_98 -ms spp.c    üũ
**  PCAT : bcc /DPC_AT -ms spp.c
*/
#include<stdio.h>
#include<dos.h>
#include<conio.h>
#include<stdlib.h>

/*
     Ϳ 
*/
int   out1;   /* LCD */
int out2;   /* LED */
int in1;    /* SW */
#include"lcd.inc"

/*
    
*/
#ifdef PC_AT
#define RBR 0 /* R    */
#define THR 0 /* W ۽   */
#define DLL 0 /*   ְ() */
#define IER 1 /*   ͷƮ 㰡 */
#define DLM 1 /*   ְ() */
#define IIR 2 /* R ͷƮ ID */
#define FCR 2 /* W FIFO  */
#define LCR 3 /*   Ʈ */
#define MCR 4 /*    Ʈ */
#define LSR 5 /*    ͽ */
#define MSR 6 /*     */
#define SCR 7 /*   ũġ */
#endif
/*
    ɣ Ʈ 巹/Ʈ 
*/
#ifdef PC_98
#define port_add     0x32
#define port_out_add 0       /*Ʈ 巹 RS232C */
#define dat_out_bit  0x02    /* data_out       DTR */
#define clock_cont   0x20    /* clock_cont     RTS */
#define latch_cont   0x08    /* latch_cont     TXD */
#define port_in_add  0       /*ԷƮ 巹 RS232C */
#define dat_in_bit   0x80    /*Է data_in        DSR */
#endif
#ifdef PC_AT
#define port_add     0x3f8
#define port_out_add MCR      /*Ʈ 巹 RS232C */
#define port_brk_add LCR      /* send break 巹 */
#define dat_out_bit  0x01     /* data_out       DTR */
#define clock_cont   0x02     /* clock_cont     RTS */
#define latch_cont   0x40     /* latch_cont     TXD */
#define port_in_add  MSR      /*ԷƮ 巹 RS232C */
#define dat_in_bit   0x20     /*Է data_in        DSR */
#endif

int port_base,regs,regs2;

/*--- Ŀ Ÿ Ʈ ---
**/
void wait(void)
{
#ifdef PC_98
   outportb(0x5c,0); /*PC98 1uS*/
#endif
#ifdef PC_AT
   inportb(port_base+port_in_add); /*dummy*/
#endif
}
/*=============================
**    Ʈ  α׷
**===========================*/
/*---  1Ʈ  ƾ ---
**  dat1out(dat)
**  in :
**    dat = Ʈ  
*/
void dat1out(int dat)
{
  if(dat) outportb(port_base+port_out_add,(regs=regs & ~dat_out_bit));
  else outportb(port_base+port_out_add,(regs=regs | dat_out_bit));
}
/*---  1Ʈ Է ƾ ---
**  dat1in()
**  out : Ʈκ  Է
*/
int dat1in(void)
{
  if((inportb(port_base+port_in_add)) & dat_in_bit) {/*printf("0");*/ return
(0);}
  else {/*printf("1");*/ return(1);}
}
/*--- Ŭ  ƾ ---
**  clkout()
*/
void clkout(void)
{
int i;
  outportb(port_base+port_out_add,(regs=regs | clock_cont));  /*set*/
  for(i=0;i<100;i++) wait();
  outportb(port_base+port_out_add,(regs=regs & ~clock_cont)); /*clear*/
  for(i=0;i<100;i++) wait();
}
/*--- ͷġ  ƾ ---
**  latchout()
*/
void latchout(void)
{
int i;
#ifdef PC_98
  outportb(port_base+port_out_add,(regs=regs | latch_cont));  /*set*/
  for(i=0;i<100;i++) wait();
  outportb(port_base+port_out_add,(regs=regs & ~latch_cont)); /*clear*/
  for(i=0;i<100;i++) wait();
#endif
#ifdef PC_AT
  outportb(port_base+port_brk_add,(regs=regs | latch_cont));  /*set*/
  for(i=0;i<100;i++) wait();
  outportb(port_base+port_brk_add,(regs=regs & ~latch_cont)); /*clear*/
  for(i=0;i<100;i++) wait();
#endif
}
/*=============================
**      α׷
**===========================*/
/*---  1Ʈ  ƾ ---
**  data8(dat)
**  in :
**    dat = Ʈ  
**  out : Ʈκ  Է
*/
int data8(int out_dat)
{
int i,in_dat;
   in_dat=0;
   for(i=0;i<8;i++) {
      dat1out(out_dat & 0x80); out_dat=out_dat << 1;
      in_dat=in_dat << 1; in_dat=in_dat | dat1in();
      clkout();
   }
  return(in_dat);
}

/*--- ü   ƾ ---
**  dsend()
**  out1,out2 = Ʈ  
*/
void dsend(void)
{
  in1=data8(in1);   data8(out2); data8(out1);
  latchout();
}
/*--- ü  Է ƾ ---
**  drecv()
**  in1 = Ʈκ  Է
*/
void drecv(void)
{
  latchout();
  in1=data8(in1);   data8(out2); data8(out1);
}
/*=============================
**     α׷
**===========================*/
void main(int argc,char *argv[])
{
int i,dat,m,h,d;
int   key,use_serial,check_mode,out2r,in1r;
struct time t;
int XX[]={3,7,11,15,3,7,11,15};
int YY[]={1,1,1,1,2,2,2,2};

   /*ɼ ؼ ó*/
  port_base=port_add;
   puts("øƮ ̿ з  Ʈѷ");
   for(i=1;i<argc;i++) {
      if(argv[i][0]=='/' || argv[i][0]=='-') { /* option delect */
         key=toupper(argv[i][1]);
         if(key=='A') port_base=atoi(&argv[i][2]); /*port address*/
#ifdef PC_AT
         if(key=='C') {dat=atoi(&argv[i][2]);     /*com port set*/
            port_base=peek(0x40,(dat-1)*2);
            if(port_base==0) { /*com port */
               puts(" COM PORT  ");
               exit(1); /*error stop*/
            }
         }
#endif
      }
   }
   printf("port address=%XH\n",port_base);

   /*ø ̽ ʱȭ*/
#ifdef PC_98
   /*--- ͷƮ ũ(ý Ʈ 8255) ---*/
   outportb(0x35,(inportb(0x35) & 0xF8));
   /*--- 8251 ʱȭ ---*/
   outportb(port_base,0); wait();    /**/
   outportb(port_base,0); wait();
   outportb(port_base,0); wait();
   outportb(port_base,0x40); wait(); /*Ʈ*/
   outportb(port_base,0x4e); wait(); /*⼳*/
   outportb(port_base,regs=0x37);    /*Ŀǵ */
#endif
#ifdef PC_AT
   /*--- 8250 ʱȭ ---*/
   outportb(port_base+MCR,0x00); wait();
   outportb(port_base+LCR,0x00); wait();
   outportb(port_base+IER,0x00); wait();

   /*--- Ʈ  ---*/
   outportb(port_base+LCR,0x80); wait(); /*DLAB=1*/
   outportb(port_base+DLL,1); wait(); /*(115Kbps)*/
   outportb(port_base+DLM,0); wait(); /*(115Kbps)*/
   outportb(port_base+LCR,0x03); wait(); /*DLAB=0*/

   /*--- 8250  ---*/
   outportb(port_base+LCR,0x03); wait(); /*DATA=8bit STOP=1bit party=non*/
   outportb(port_base+IER,0x00); wait(); /*ͷƮ */
   outportb(port_base+MCR,regs2=0x03); wait(); /*DTR,RTS=on OUT2=off*/
#endif

  out1=out2=0;
  dsend();
  LCDinit();
  LCDputs("1=0 2=0 3=0 4=0");
  LCDxy(1,2);
  LCDputs("5=0 6=0 7=0 8=0");
  out2r=out2; in1r=255;
  puts("ESC ");

   /*η*/
  for(;;) {
    /*Ű Էó*/
      if(kbhit()) {
      if((key=getch())==27) break; /**/
      if(key>='1' && key<='8') { /*ȿԷ*/
        d=1 << (key-'1');
        out2=out2 ^ d;
      }
    }
    /*Ʈ Էó*/
    else {
      drecv();
      if(in1==255) in1r=255;
      if(in1!=in1r) { /*ȿԷ*/
        out2=out2 ^ ~in1;
        in1r=in1;
      }
    }
    /*ġ ó*/
    if(out2!=out2r) {
      for(i=0;i<8;i++) {
        if((out2 >> i) & 1) d=1; else d=0;
        printf("%d=%d ",i+1,d);
        if(((out2 >> i) & 1)!=((out2r >> i) & 1)) {/* ٸ  ǥ */
          LCDxy(XX[i],YY[i]); 
          if(d) LCDputs("1"); else LCDputs("0");
        }
      }
      puts("");
      out2r=out2;
    }
  }
}
