   TITLE   "GPIB ø ȯϴ α׷ : PIC16C55 or PIC16C57"

;     Processor       16C55 or 16C57
;*****************************************************************************
; GPIB ø(RS232C) ȯϴ α׷
; RS232c   : 9600, 8Ʈ 1Ʈ, иƼ , ÷ 
; PIC16C55 or 16C57    : 20MHz.
; 1999 5/10, 12/11 by S.Satoh
;*****************************************************************************

 CBLOCK 0x0   ;  巹 
   _indf,_tmr0,_pcl,_status,_fsr
   _porta,_portb,_portc
 ENDC
; _status:ͽ ϴ Ʈ 
_c    equ   0
_dc   equ   1
_z    equ   2
_rp0 equ   5
; _porta: AƮ ϴ Ʈ 
_RSout   equ  2
_oATN    equ  3
; _portb: BƮ ϴ Ʈ 
_ren     equ  0  ; GPIBREN
_eoi     equ  1  ; GPIBEOI
_dav     equ  2  ; GPIBDAV
_nrfd    equ  3  ; GPIBNRFD
_ndac    equ  4  ; GPIBNDAC
_ifc     equ  5  ; GPIBIFC
_srq     equ  6  ; GPIBSRQ
_atn     equ  7  ; GPIBATN

 CBLOCK 0x08  ;   巹 
   _RGstatus  ;  ͽ
   _ver        ; Ͻ 
   _RSbit      ; ø   Ʈ ȣ
   _RSbuf      ; ø 
   _GPnow      ; GPIB óȣ
   _Dbuf       ; GPIB  
 ENDC
;
; _RGstatus: RG ͽ ϴ Ʈ 
_RSon       equ  1  ; ø  
_RSend      equ  2  ; ø Ʈ 
_GPlisten  equ   5  ; GPIB 
;

   ORG     0
   goto    Start
;
SetWaitSub:   ; Ÿ̸ӿ ðǥ
   andlw 0x7
   addwf _pcl,1
   retlw 0x10 ;  100 micro second
   retlw 0x20 ;  200 micro second
   retlw 0x30 ;  300 micro second
   retlw 0x41 ;  400 micro second
   retlw 0x51 ;  500 micro second
   retlw 0x61 ;  600 micro second
   retlw 0x71 ;  700 micro second
   retlw 0x82 ;  800 micro second

; retlw 0xe-1    ;#14 Ŭ 4MHz 
; retlw 0x1b-1   ;#27 Ÿ̸ӿ ðǥ
; retlw 0x28-1   ;#40
; retlw 0x35-1   ;#53
; retlw 0x42-1   ;#66
; retlw 0x4f-1   ;#79
; retlw 0x5c-1   ;#92
; retlw 0x69-1   ;#105

;*******************************************************************

Start:
; movlw 0xff   Ŀ÷  
   movlw 0xfb
   movwf _porta
   movwf _portb
   movlw 0x3  ; _RSout is output
   tris _porta
   movlw 0xe7 ; NRFD,NDAC  
   tris _portb
   movlw 0xff ; GPIB   ׻ Է»
   tris _portc

   movlw 0x4  ; TMR0  Ŭ 1/32(6.4 uS)
   option      ; 9600 16.276 īƮ/

; Ŭ 4MHz    Ѵ
; movlw 0x2   ; TMR0 internal 1/8(8 uS) for 4 MHz
; option      ; 9600 baud >> 13.02 count/baud

   clrf _RSbit
   clrf _RSbuf
   clrf _GPnow
   clrf _RGstatus
   bcf   _portb,_ndac
; bsf    _porta,_RSout   Ŀ÷  
   bcf   _porta,_RSout
Main_00:
   clrwdt
   btfsc _portb,_ifc      ;IFC ο ΰ?
   goto Main_01

   bcf   _RGstatus,_GPlisten ;IFC ο̸,
   bsf   _portb,_ndac        ;𸮽ʷ NDAC 
   clrf _GPnow

Main_01:
   btfss _RGstatus,_RSon     ;ø ΰ?
   goto Main_10  ; to GPIB loop

; --------- ø  Ʈ ó ---------
   btfsc _RGstatus,_RSend   ;Ʈ ΰ?
   goto Main_02

   movf _Dbuf,0              ;ʱ⼳ Ǿ ִ°?
   btfsc _status,_z
   goto Main_02

; --------- ø  Ʈ ° ʱ⼳ ---------
   movwf _RSbuf
   clrf _RSbit
   clrf _Dbuf
; bcf    _porta,_RSout  Ŀ÷  
   bsf   _porta,_RSout    ;start bit
   clrf _tmr0
   goto Main_00

Main_02:
   movf _RSbit,0
   call SetWaitSub
   subwf _tmr0,0
   btfss _status,_c       ;Ʈ  ðΰ?
   goto Main_00

   btfss _RGstatus,_RSend
   goto Main_03

;  --------- Ʈ ó ---------
; bsf    _porta,_RSout  Ŀ÷  
   bcf   _porta,_RSout
   incf _RSbit,1          ;Ʈ ٸ
   decf _RSbit,0
   btfsc _status,_z
   goto Main_10

   bcf   _RGstatus,_RSend
   bcf   _RGstatus,_RSon
   goto Main_10

Main_03:
   rrf   _RSbuf,1         ;1Ʈ  Ʈ
   btfsc _status,_c
; bsf    _porta,_RSout  Ŀ÷  
   bcf   _porta,_RSout
   btfss _status,_c
; bcf    _porta,_RSout  Ŀ÷  
   bsf   _porta,_RSout

   incf _RSbit,1
   movlw 8
   subwf _RSbit,0
   btfss _status,_c
   goto Main_00  ; RS loop

; --------- Ʈ(1Ʈ)  ó ---------
   clrf _GPnow      ; initialize GPIB control
   bsf   _RGstatus,_RSend
   clrf _RSbit
   clrf _tmr0


;##################### GPIB ó ###################
Main_10:               ; do GPIB
   btfss _portb,_atn
   bcf   _porta,_oATN ; ATN LED on
   btfsc _portb,_atn
   bsf   _porta,_oATN ; ATN LED off

   movf _GPnow,0
   btfss _status,_z   ;  о̱ óΰ? 
   goto Main_30

   btfss _portb,_dav  ; DAV  ΰ?
   goto Main_00

;  ---------  о̱ ó κ ---------
   incf _GPnow,1
   btfsc _RGstatus,_GPlisten ; ̸
   bcf   _portb,_ndac        ;NDAC ο Ѵ
   btfss _portb,_atn         ;Ǵ ATN ο̸
   bcf   _portb,_ndac        ;NDAC ο Ѵ

   bsf   _portb,_nrfd        ;NRFD  · Ѵ
   goto Main_00

Main_30:            ;do GPIB
   movf _GPnow,0
   xorlw 1           ; о̱ ó κΰ?
   btfss _status,_z
   goto Main_40

   btfss _portb,_atn  ;ATN ο̸
   bcf   _portb,_ndac ;NDAC ο · Ѵ

   btfsc _portb,_dav  ;DAV ο Ǿ°?
   goto Main_00

;  ---------  о̱ ó κ ---------
   incf _GPnow,1
   movf _portc,0       ;͹ ͸ оδ
   xorlw 0xff
   movwf _Dbuf
   bcf   _portb,_nrfd ;NRFD ο Ѵ
   bsf   _portb,_ndac ;NDAC ̷ Ѵ
   goto Main_00

Main_40:         ; do GPIB
   movf _GPnow,0
   xorlw 2              ; о̱ ó κΰ?
   btfss _status,_z
   goto Main_00

   btfss _portb,_dav  ;DAV  · Ǿ°?
   goto Main_00

;  ---------  о̱ Ĺ óκ ---------
   clrf _GPnow
   bsf   _RGstatus,_RSon

   btfsc _portb,_atn  ;ATN ο ΰ?
   goto Main_00

;  --------- Ŀǵ  ó ---------
   movf _Dbuf,0
   andlw 0xe0
   xorlw 0x20                ;Ʈѷ  ΰ?
   btfsc _status,_z
   bsf   _RGstatus,_GPlisten ; ͷ ȴ

   movf _Dbuf,0
   xorlw A'?'                ;𸮽ΰ?
   btfsc _status,_z
   bcf   _RGstatus,_GPlisten ; ʷ  ʴ´

   goto Main_00

   END

