/*
**  ңϣ ķ   α׷
**
**     rom ϸ    :   ȣţ 
**
**    for BC++4.0J
**  PC98 : bcc /DPC_98 -ms rom.c
**  PCAT : bcc /DPC_AT -ms rom.c
*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<dos.h>
#include<io.h>
#include<fcntl.h>
#include<sys\stat.h>
#include"parallel.h"

/*
**  LATCH CONTROL (ġ ֱ Ʈ )
*/
#define ADD_HI0  SLCTIN   /* HIGH ADDRESS LATCH */
#define ADD_HI1  ~SLCTIN
#define ADD_LO   ~INIT    /* LOW ADDRESS LATCH */
#define DATA_SET INIT     /* DATA LATCH */
/*
**  ROM CONTROL (ңϣ   Ʈ )
*/
#define ROM_WR STROBE     /* ROM WRITE */
#define ROM_RD ~STROBE
/*
**  ķ ON/OFF
*/
#define EMU_ON  AUTOFD
#define EMU_OFF ~AUTOFD

unsigned int ADDreg;    /* 巹 ġ   */
/*
**   ȣţ ȯ  
*/
#define MAX_LINE 80   /*  ȣţ ȯ  */
/*
**   ȣţ ȯԼ
*/
int lineconv(char *buff);          /* 1 ȯ ƾ */
int checksum(char *buff);          /* üũ üũ */
int hex2(char *buff);              /* HEX 2ڸ int ȯ */
int hex1(char data);               /* HEX 1ڸ int ȯ */
/*
**  ңϣ ķͿ Լ
*/
void init(void);                    /* ʱȭ */
void SET(unsigned int add,unsigned char dat);    /* ROM ֱ */
void bitset(unsigned int add,unsigned char dat); /* Ʈ   */

/*=============================================================================
**   α׷
*/
void main(int argc, char **argv)
{
  FILE      *fp;
  char      linebuff[MAX_LINE+1];
  unsigned int  outcount = 0;

  printf("\nңϣ ķͿ,   α׷\n");
  if (argc == 1){
    printf("\n ROM FILENAME( HEX )\n");
    exit(1);
  }

  init(); /* ʱȭ */

  bitset(CP,EMU_OFF);
  if ((fp = fopen(argv[1],"rt")) != NULL){
    while(fgets(linebuff,MAX_LINE,fp) != NULL){
      if (linebuff[0] == ':'){      /*  ΰ ':' ܴ̿  */
        if (checksum(linebuff+1) == 0){
          outcount += lineconv(linebuff+1);
        }else{
          printf("\nüũ .\n%s\n",linebuff);
          pend();
          exit(1);
        }
      }
    }
    fclose(fp);
    bitset(CP,EMU_ON);
  }else{
    printf("%s :    ϴ.\n",argv[1]);
    pend();
    exit(1);
  }
  printf("\n%u Ʈ ߽ϴ.\n",outcount);
//  pend();
}

/*=============================================================================
**  ȣţ ȯ
**
**Է¡buff : ڣȣţأ .  ''  Ѵ.
**  ¡     :   .
*/
int lineconv(char *buff)
{
  int       i,len,count = 0;
  unsigned int  adres;

  len = hex2(buff);               /*     */
  adres = (unsigned int)(hex2(buff+2)<<8)+hex2(buff+4); /* 巹 */

  for (i = 0; i < len; i++){
    SET(adres+i,hex2(buff+8+i*2)); /* ROM ִ´ */
    count++;
  }
  return(count);
}
/*
** üũ üũ
**
**Է¡buff :  ȣţ  . ''  Ѵ.
**  ¡ : üũ 
*/
int checksum(char *buff)
{
  int   len,i,sum=0;

  len = hex2(buff);             /*      */
  for (i = 0; i < (len + 5); i++){
    sum = (sum+hex2(buff+i*2))&0xff;
  }
  return(sum);
}
/*
**ȣţ ڸ̳ʸ ȯ
**
*/
int hex2(char *buff)
{
  return(hex1(buff[0])*16+hex1(buff[1]));
}

/*
**ȣţ ڸ̳ʸ ȯ
**
*/
int hex1(char data)
{
  static char   hexdata[] = "0123456789ABCDEF";
  int       i;

  for (i = 0; i < 16; i++){
    if (data == hexdata[i])   return(i);
  }
  return(-1);
}

/*=============================================================================
**  ͸ ķͿ 
**  SET(add,dat)
**  in :
**    add = ңϣ 巹
**    dat = ֱ 
*/
void SET(unsigned int add,unsigned char dat)
{
  if((ADDreg & 0xFF00)!=(add & 0xFF00)) { /* Ʈ  */
    ADDreg=add;
    bitset(DP,(add >> 8));
    bitset(CP,ADD_HI1);
    bitset(CP,ADD_HI0);
  }
  bitset(CP,DATA_SET);
  bitset(DP,(add & 0xFF));  /*Ʈ */
  bitset(CP,ADD_LO);
  bitset(DP,dat);            /* */
  bitset(CP,DATA_SET);
  bitset(CP,ROM_WR);
  bitset(CP,ROM_RD);
}
/*
**  ķ ʱȭ
**  init()
*/
void init(void)
{
  if(pinit()) {puts(" 尡 ƴϴ"); exit(1);}
  outportb(CP,0x00);
  bitset(CP,DATA_SET);
  bitset(CP,ADD_HI0);
  bitset(CP,ROM_RD);
  /* ADDreg ķ  巹 ġ  */
  ADDreg=0xFFFF;
  SET(0,0);
}
/*
**  Ʈ Ʈ 
**  bitset(port,bitdat)
**    port : Ʈ 巹
**    bit  : Ʈ (MSB=0 OR bit / MSB=1 AND ~bit)
*/
void bitset(unsigned int add,unsigned char dat)
{
unsigned char work;
  if(add==DP) outportb(add,dat);
  if(add==CP) {
    work=inportb(add);
    if(dat&0x80) work=work&dat;/**/
    else work=work|dat; /**/
    outportb(add,work);
  }
}
