//===========================================================================
// н ⺻ Ŭ
// (C)ͪϼᶡ1996/8/1 1997/5/5
//===========================================================================
#include  <stdio.h>
#include  "scope.h"
extern  int FFTMode;
//----------------------------------
Scope::Scope(void)
{
  int n;
  for(n=0; n<TMAX;  n++)  { tbuf[n] = 0;  df = 0;}
  Wide = 20;  //켱  
  YDiv = 500;
  InCh = 0;
  fdif = 0.0;
  CrosMode=LineMode = 0;
  XDotData  = 2;
  XDataTime = 1.0;
}
//----------------------------------
void  Scope::ReDraw(TDC &dc, TRect& tr)   //ܼ ľ
{
  DrawFrame(dc, tr);
  dc.SetROP2(R2_MERGEPENNOT );
  DrawMData(dc, tr);

}
//----------------------------------
//ο ͱ ľ
#pragma argsused
void  Scope::Flush(TRect &tr, TDC &dc, int *d)
{
  int n, nx;
  dc.SetROP2(R2_MERGEPENNOT );
  DrawMData(dc, tr);
  for(n=0, nx=GetXDataSize();  n<nx ; n++)  tbuf[n] = d[n];
  DrawMData(dc, tr);
}
//----------------------------------
//  ׸
void  Scope::DrawFrame(TDC &dc, TRect& tr)
{
  int n;
  TRect   mr;
  TPoint  ms, me;

  CrosMode=0;
  dc.FillRect(tr, TBrush(TColor::Gray));  // ū 

  #define HGRID 8
  #define VGRID 10
  Frame.left = tr.right/30;  Frame.right = tr.right * 29/30;
  Frame.top = tr.bottom/30;  Frame.bottom = tr.bottom *29/30;
  YDotDiv = (Frame.bottom-Frame.top)/HGRID;
  Frame.bottom = Frame.top+YDotDiv * HGRID;
  XDotDiv = (Frame.right-Frame.left)/VGRID;

  dc.FillRect(Frame, TBrush(RGB(0xf0,0xf0,0xf0))); // г

  dc.SelectObject(TPen(TColor::Black));
  dc.Rectangle(Frame);

  Wide = Frame.right - Frame.left - 1;
  if(Wide<1)  Wide = 1;

  //׸
  //Ⱦ
  #define HGRID 8
  ms.x = Frame.left;  me.x = Frame.right;
  dc.SelectObject(TPen(TColor::LtBlue, 1, PS_DOT));
  for(n=1; n<HGRID; n++)  {
    ms.y = me.y = Frame.top+(YDotDiv*n);
    dc.MoveTo(ms);  dc.LineTo(me);
  }
  dc.SelectObject(TPen(TColor::LtBlue, 1, PS_SOLID));
  ms.y = me.y = Frame.top+YDotDiv*HGRID/2;
  dc.MoveTo(ms);  dc.LineTo(me);    // 


  //
  dc.SelectObject(TPen(TColor::LtBlue, 1, PS_DOT));
  ms.y = Frame.top; me.y = Frame.bottom;
  for(n=1; n<VGRID; n++)  {
    ms.x = me.x = Frame.left +((Frame.right-Frame.left)*n)/VGRID;
    dc.MoveTo(ms);  dc.LineTo(me);
  }

  // ǥ
  if(df) delete df;
  n = (Frame.bottom-Frame.top)/16;
  if(n<12) n=12;
  CharH = n;
  df = new TFont(n, n/2);

  dc.SelectObject(*df);
  dc.SetTextAlign(TA_LEFT | TA_TOP);
  me.x = Frame.left+2;  me.y = Frame.top +2;
  if(Wide>32) dc.TextOut(me, DStrForm(InCh, DStr));

}
//----------------------------------
//  ׸, f=0 ű ȭ  f#0   ׸
#pragma argsused
void  Scope::DrawMData(TDC &dc, TRect& tr)
{
  TPoint me;
  TPoint  p, p1, q;
  int n,  m, xdsize = GetXDataSize();
  double  d;
  MaxD = -4096; MinD=4096;

  if(LineMode || FFTMode)  dc.MoveTo(Frame.left, Frame.top + YDotDiv*HGRID/2);

  dc.SelectObject(TPen(TColor::Black, 1, PS_SOLID));

  for(n=0, p.x = Frame.left+1;  n<xdsize; n++, p.x += XDotData)  {
    m = tbuf[n];
    d = ((double)m*YDotDiv)/YDiv;
    p.y = Frame.top + YDotDiv*HGRID/2 - d;
    if(FFTMode)  {
      dc.LineTo(p1=p); p1.x++;  dc.MoveTo(p1);
    } else  if(LineMode)  {
      dc.LineTo(p);
    } else  {
      dc.MoveTo(p); q=p; q.x +=  XDotData;  dc.LineTo(q);
    } //dc.SetPixel(p, TColor::Black);
    if(m>MaxD) MaxD=m;
    if(m<MinD) MinD=m;
  }
  if(Wide>32) DrawStr1(dc, DStrForm(InCh, DStr));

}
//----------------------------------
void  Scope::DrawStr1(TDC &dc, char *cp)
{
  TPoint me;
  dc.SelectObject(*df);
  dc.SetTextAlign(TA_LEFT | TA_TOP);
  me.x = Frame.left+2;  me.y = Frame.top +2;
  dc.TextOut(me, cp);
}
//----------------------------------
void  Scope::DrawStr2(TDC &dc, char *cp)
{
  TPoint me;
  dc.SelectObject(*df);
  dc.SetTextAlign(TA_LEFT | TA_TOP);
  me.x = Frame.left+2;  me.y = Frame.top +2 + CharH;
  dc.TextOut(me, cp);
}
//----------------------------------
//ǥϴ ڿ   20 ̳
char  *Scope::DStrForm(int d, char *cp)
{
  double  xd = XDataTime * XDotDiv/XDotData;
  sprintf(cp, " CH%1d %3.2fms/div %3dmV/div Max%4d Min%4d mV ", d, xd, YDiv, Ma
xD, MinD);
  return  cp;
}
//----------------------------------
//ȭ ġ ͸ Ŀ ڷ ǥ
//mode = 0  ͸
//mode = 1  Ϳ 2°  
void  Scope::DrawCross1(TDC &dc, TPoint &point, int mode)
{
  int n,  m;  //, xdsize = GetXDataSize();
  double  d;
  TPoint  ms, me, p;

  if(CrosMode) {
    CrosMode=0;
    DrawCross1(dc, CrosP, mode);
  }
  CrosMode=1;
  dc.SetROP2(R2_XORPEN );

  n = point.x - Frame.left;
  if(n<0) n=0;
  if(n>Wide)  n=Wide;
  n /=  XDotData;

  m = tbuf[n];
  d = ((double)m*YDotDiv)/YDiv;

  dc.SelectObject(TPen(TColor::LtGray, 1, PS_SOLID));
  //
  ms.x = me.x = Frame.left + n*XDotData;  //point.x;
  ms.y = Frame.top; me.y = Frame.bottom;
  dc.MoveTo(ms);  dc.LineTo(me);

  //Ⱦ
  ms.x = Frame.left;  me.x = Frame.right;
  ms.y = me.y = Frame.top+YDotDiv*HGRID/2 - d;
  dc.MoveTo(ms);  dc.LineTo(me);

  CrosP = point;

  double  freq, xd = n*XDataTime;
  if(mode==0) {
    if(FMode) {
      sprintf(DStr, " %4.1fHz %3.1fdBV     ",
              xdmemo=n*1.0/XDataTime, (mmemo=m)/50.0-20 - fdif);
    } else  {
      sprintf(DStr, " %3.2fmsec %3ddBV     ", xdmemo=xd, mmemo=m);
    }
  } else  {
    if(FMode) {
      sprintf(DStr, " %4.1fHz %3.1fdBV     ",
              fabs(xdmemo-(n*1.0/XDataTime)), (m-mmemo)/50.0);
    } else  {
      if(xd != xdmemo) freq = 1000/fabs(xd-xdmemo); else freq=0.0;
      sprintf(DStr, " Diff %+3.2fmsec[AC=%4.1fHz] %+3dmV     ",
              xd-xdmemo, freq, m-mmemo);
    }
  }
  DrawStr2(dc, DStr);
}
//----------------------------------

