#ifndef  __DSCOPE_H
#define  __DSCOPE_H
//===========================================================================
// н
// (C)ͪϼᶡ1996/8/1 1997/5/5
//===========================================================================
#include  <owl\owlpch.h>
#include  <owl\applicat.h>
#include  <owl\window.h>
#include  <owl\framewin.h>
#include  "dscope.rh"
#include  "gidadc.h"
#include  "scope.h"
#include  "fft.h"
#include  "profile.h"

extern  Profile pro;
//=====================================================
class DSCOPEWINApp : public TApplication
{
  public:
  DSCOPEWINApp() : TApplication() {};
  void InitMainWindow();

  DECLARE_RESPONSE_TABLE(DSCOPEWINApp);
};
//----------------------------------
class DSCOPE : public  TFrameWindow,  public  Scope
{
//  int InCh;
  int Freeze;
  int CMode;
  //  int       FFTMode;
  public:
  //data
  GidADC ADC;

  DSCOPE(TWindow *parent, const char *title);
  ~DSCOPE(void);
//  bool IdleAction(long idleCount);
  void  EvTimer(uint);
  void  SetupWindow(void);
  void Paint(TDC& dc, bool erase, TRect& rect);
  void  EvSize(UINT, TSize &);
//  bool  IdleAction(long idleCount);
  void  AdcRun(void);
  void  RePaint(void);
  char  *DStrForm(int d, char *cp);
  void  CM_TrigP(void);
  void  CM_TrigM(void);
  void  CM_TrigNone(void);
  void  CM_TAdj(void);
  void  CM_InCh0(void);
  void  CM_InCh1(void);
  void  CM_InCh2(void);
  void  CM_InCh3(void);
  void  CM_InCh4(void);
  void  CM_InCh5(void);
  void  CM_InCh6(void);
  void  CM_InCh7(void);

  void  CM_YDiv4000(void);
  void  CM_YDiv1000(void);
  void  CM_YDiv500(void);
  void  CM_YDiv200(void);
  void  CM_YDiv100(void);
  void  CM_YDiv50(void);
  void  CM_YDiv20(void);

  void  CM_LineMode(void);
  void  CM_Freeze(void);
  void  CM_High(void);
  void  CM_Low(void);
  void  CM_Fft(void);
  void  CM_FNone(void);
  void  CM_FTri(void);
  void  CM_FSin(void);
  void  CM_FHun(void);
  void  CM_FHum(void);
  void  CM_Ver(void);
  void  EvMouseMove(uint modKeys, TPoint& point);
  void  EvLButtonDown(uint modKeys, TPoint& point);
  void EvLButtonDblClk(uint modKeys, TPoint& point);

  DECLARE_RESPONSE_TABLE(DSCOPE);
};
//----------------------------------
#endif  __DSCOPE_H

