/*
**  3  µ DS1820  α׷ ver.1.01
**
**   : DS1820F [/t#] [/n#] [/fFileName]
**                /t# : #=10-32000() ð(10)
**                /n# : #=1-32000(ȸ) ȸ(6)
**                /fFileName : ϸ(DS1820.OUT)
**
** IBM-PC  øƮ ãϣͣ 
**
**    for BC++4.0J
** PC98 : bcc /DPC_98 -ms ds1820f.c
** PCAT : bcc /DPC_AT -ms ds1820f.c
*/
#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<math.h>
#include<dos.h>
#include<time.h>
#include<string.h>
#include<ctype.h>
/*
    ɣƮ 巹Ʈ 
*/
#ifdef PC_98
#define port_out_add 0x32    /*Ʈ 巹 RS232C */
#define dat_out_bit  0x02    /*Ʈ Ʈ DTR */
#define volt_plus    0x20    /*(=1)       RTS    */
#define volt_minus   0x08    /*(=0)       TXD    */
#define port_in_add  0x32    /*ԷƮ 巹 RS232C */
#define dat_in_bit   0x80    /*ԷƮ Ʈ DSR */
#endif
#ifdef PC_AT
#define RSport 0x2f8          /*COM1 = 3fx  COM2 = 2fx  */
#define port_out_add RSport+4 /*Ʈ 巹 RS232C */
#define dat_out_bit  0x01     /*Ʈ Ʈ DTR */
#define volt_plus    0x02     /*(=1)       RTS */
#define volt_minus   0x00     /*(=0/̻)TXD */
#define port_in_add  RSport+6 /*ԷƮ 巹 RS232C */
#define dat_in_bit   0x20     /*ԷƮ Ʈ DSR*/
#endif
/*
  DS1820  Ÿ̹
*/
#define tRSTL 70
#define tRSTH 50
#define tSLOT 9

/*
   ʱȭ
*/
int itime=10;                  /*Ʈ ð */
int count=6;                   /*Ʈ ȸ*/
char fname[32]={"DS1820.OUT"}; /* ϸ*/
long timeup_time=50000L;       /*ŸӾƿ ī (min 4800nS)*/
unsigned char regs;

/*
** Ŀ Ÿ Ʈ
**/
void wait(void)
{
#ifdef PC_98
   outportb(0x5c,0); /*PC98 1uS*/
#endif
#ifdef PC_AT
   inportb(RSport); /*dummy*/
#endif
}
/*
** ãңû(CRC=x8+x5+x4+1)
** crc(in,out)
** in :
**    in  = μ
**    out = 
** out : ãң 갪
*/
int crc(int in,int out)
{
int i,c;
   for(i=0;i<8;i++) {
      c=(in&1)^(out&1);
      out=out>>1;
      if(c) out=out^0x8c;
      in=in>>1;
   }
   return(out);
}
/*=== α׷Ӻ ͹ Ÿ̸ ====================================*/
/*
** Уɣԡ巹 
*/
#ifdef PC_98
#define PITD    0x75  /*ī Ʈ */
#define PITC    0x77  /* */
#define PITinit 0x94  /* ʱȭ 2ch,,mode=2*/
#endif
#ifdef PC_AT
#define PITD    0x42  /*ī Ʈ */
#define PITC    0x43  /* */
#define PITinit 0x94  /* ʱȭ 2ch,,mode=2*/
#endif
/*
** УɣԿ Ŭ ļ 
**/
#define PITfreq25 2457600 /*PC98 system clock = 5/10MHz*/
#define PITfreq20 1996800 /*PC98 system clock = 8MHz*/
#define PITfreq12 1193180 /*PCAT*/

int ts;

/*
**  Ÿ̸ īƮ 
** TMset()
**    out :
**    ts  = 10uS  īƮ
**/
void TMset(void)
{
double dd;
#ifdef PC_98
   /*ý ŬϿ  Ÿ̸ Ŭ */
   if(peekb(0,0x501)&0x80) dd=PITfreq20; else dd=PITfreq25;
#endif
#ifdef PC_AT
  dd=PITfreq12;
   /*Уɣԡ  ϣ*/
   outportb(0x61,(inportb(0x61) | 0x01));
#endif
   ts=floor((dd/(100000))+0.5);
}
/*--- Ʈ   ---
**  wait10(tm)
**  in :
**    tm = Ʈ ð(10) 165000
*/
void wait10(unsigned int tm) /*10uS*/
{
int w1,w2;
  /*Уɣ ī б*/
  w1=inportb(PITD);
   for(;tm>0;tm--) {
    do {/*īͰ  ϱ ٸ*/
      if((w2=inportb(PITD))>=w1) w2-=256;
    } while(w1-w2<ts);
    w1=(w1-ts)&0xff;
  }
}
/*--- Ʈ   ---
**  wait100(tm)
**  in :
**    tm = Ʈ ð(100m) 165000
*/
void wait100(unsigned int tm) /*100mS*/
{
   for(;tm>0;tm--) wait10(10000);
}
/*=== ģӣ  ƾ ==========================================*/
/*--- Ʈ  ƾ ---
**  bitout(dat)
**  in :
**    dat = Ʈ  
*/
void bitout(int dat)
{
  if(dat) outportb(port_out_add,(regs=regs & ~dat_out_bit));
  else outportb(port_out_add,(regs=regs | dat_out_bit));
}
/*--- Ʈ Է ƾ ---
**  bitin()
**  out : Ʈκ  Է
*/
int bitin(void)
{
  if((inportb(port_in_add)) & dat_in_bit) return(0);
  else return(1);
}
/*--- High/Low Է´ ƾ ---
**  waitlow()
**    low Ǵ  ٸ
**  waithigh()
**    high Ǵ  ٸ
**  ð(min 240nS) ϸ ŸӾƿ, α׷ Ѵ
*/
void waitlow(void) /*low  */
{
long i;
  for(i=0;i<timeup_time;i++) if(bitin()==0) break;
  if(i==timeup_time) {puts("time out"); exit(1);}
}
void waithigh(void) /*high */
{
long i;
  for(i=0;i<timeup_time;i++) if(bitin()==1) break;
  if(i==timeup_time) {puts("time out"); exit(1);}
}
/*---  Ȯ ---
**  presence()
*/
void presence(void)
{
  waitlow();
  waithigh();
  wait10(tRSTH);
}
/*---  Ŀǵ ۽ ---
**  reset()
*/
void reset(void)
{
  bitout(0);
  wait10(tRSTL);
  bitout(1);
  presence();
}
/*--- send 1bit data---
**  sdata1(dat)
**  in :
**    dat = Ʈ ͸ ģӣ 
*/
void sdata1(int dat)
{
  if(!dat) {bitout(0);}
  else {bitout(0); outportb(0x5f,0); bitout(1);}
  wait10(tSLOT);
  bitout(1);
  outportb(0x5f,0);
}
/*--- get 1bit data---
**  gdata1()
**  out : Ʈ ͸ ģӣκ ޴´
*/
int gdata1(void)
{
int dat;
  bitout(0);
//  outportb(0x5f,0);
  bitout(1);
  wait10(2);
  dat=bitin();
  wait10(tSLOT);
  return(dat);
}
/*--- send 1byte data---
**  send(dat)
**  in :
**    dat = Ʈ ͸ ģӣ 
*/
void send(int dat)
{
int i;
  for(i=0;i<8;i++) {sdata1(dat & 1); dat=dat >> 1;}
}
/*--- recv 1byte data---
**  recv()
**  out : Ʈ ͸ ģӣκ ޴´
*/
int recv(void)
{
int i,dat;
  for(i=dat=0;i<8;i++) {dat=dat >> 1; if(gdata1()) dat=dat | 0x80;}
  return(dat);
}
/*=== ɣ ĵ ƾ ==============================================*/
/*
** ó  ִ ģӣ  ,,  
*/
#define MAXSTACK 16
int id[MAXSTACK][8],id_max,stack;
char s_buf[MAXSTACK+1][64],s_ptr[MAXSTACK];
/*--- trace ---
** б Ʈ̽Ѵ
**  trace()
** in :
**    stack =  ȣ
**    s_buf[][] = ɣ  
**    s_ptr[]   = б ȣ
**  out : б Ʈ ȣ
*/
int trace(void)
{
int i,gd;
   for(i=0;i<64;i++) {
    gdata1(); gdata1();/*dummy*/
      gd=s_buf[stack][i];
      if(s_ptr[stack]==i) gd++;/*ٸ бó Ѵ*/
    sdata1(gd);
      s_buf[stack][i]=gd;
      if(s_ptr[stack]==i) break;
  }
   return(++i);
}
/*--- search ---
**  search()
** б ã鼭 ɣ  ǵѴ
** in :
**    stack =  ȣ
** out :
**    stack     =  ȣ
**    s_buf[][] = ɣ  
**    s_ptr[]   = б ȣ
*/
void search(int i)
{
int j,gd;
   for(;i<64;i++) {
    gd=gdata1();
    if(gd==gdata1()) {/*б*/
         if(stack<MAXSTACK) {/*MAXSTACK Ѿٸ */
            for(j=0;j<64;j++) s_buf[stack+1][j]=s_buf[stack][j];
            s_ptr[stack]=i; s_buf[stack][i]=gd; stack++;
         }/*stack*/
      }/*gd*/
    sdata1(gd);
      s_buf[stack][i]=gd;
  }
}
/*=== Ŀǵ ó ƾ ==============================================*/
/*
**  
**  sample()
*/
void sample(void)
{
int i,temp,cnt,ch,chk[9],dat;
FILE *fv;
time_t t1,t2;
 /**/
  printf("=%d ȸ=%dȸ ϸ=%s\n",itime,count,fname);
  fv=fopen(fname,"wt");
  time(&t1);
  for(cnt=1;cnt>0;) {
    printf("%04d:",cnt);
    fprintf(fv,"%d",cnt++);
     reset();
    send(0xcc); /*ROM Skip*/
    send(0x44); /*µ*/
    recv();
    wait100(20); /*2S */
      for(ch=0;ch<id_max;ch++) {
       reset();
       send(0x55); /*ID ȸ*/
         for(i=0;i<8;i++) send(id[ch][i]); /*ID */
       send(0xbe); /* ǵ*/
       temp=(chk[0]=recv()) | ((chk[1]=recv()) << 8);
         /*ãң üũ*/
       for(i=2;i<9;i++) chk[i]=recv();
       for(i=dat=0;i<8;i++) dat=crc(chk[i],dat);
         if(dat!=chk[8]) {/*ãң  ó*/
            ch--; continue;
         }
       printf("%d.%d ",temp >> 1,(temp&1)*5);
       fprintf(fv,",%d.%d",temp >> 1,(temp&1)*5);
     }
     printf("\n");
     fprintf(fv,"\n");
    if(--count<=0) break; /**/
    t1=t1+10;
    for(t2=0;t1>t2;time(&t2)) { /*ð*/
      if(kbhit()) {cnt=0; break;}/*ߴ*/
      wait100(1);
    }
   }/*cnt*/
  fclose(fv);
  if(cnt>0) puts("Ϸ"); else puts("ߴ");
}
/*
**  read ROM command
**  readROM()
*/
void readROM(void)
{
int i;
  puts("Read ROM command");
  reset();
  send(0x33); /*READ ROM COMMAND*/
  for(i=0;i<8;i++) {
    printf("%02X:",recv());
  }
  reset();
}
/*
**  search ROM command
**  searchROM()
** in :
**    mode = ± (0=)
*/
void searchROM(int mode)
{
int i,j,dat;
  if(mode) puts("Search ROM command");
   stack=id_max=0;
   for(;;) {
     reset();
     send(0xf0); /*SEARCH ROM COMMAND*/
      if(stack==0) i=0;
      else {
         stack--;
         i=trace();/*б Ʈ̽Ѵ*/
      }
      search(i);/*ɣ  б ˻*/
      /*ɣ  ȯ*/
      for(i=0;i<8;i++) {
         for(j=dat=0;j<8;j++) {
          dat=dat >> 1;
        if(s_buf[stack][i*8+j]) dat=dat | 0x80;
         }
         id[id_max][i]=dat;
printf("%02X ",dat);
      }
puts("");
      /*ãң */
      for(i=dat=0;i<7;i++) dat=crc(id[id_max][i],dat);
      if(dat!=id[id_max][i]) {/*ãң  ó*/
         puts("CRC error. retry");
         stack=id_max=0;
         continue;
      }
      id_max++;
      if(stack<=0 || stack>MAXSTACK || id_max>MAXSTACK) break;
   }
   /*ɣ ǥ*/
   if(mode)
      for(i=0;i<id_max;i++) {
         for(j=0;j<8;j++) printf("%02X ",id[i][j]);
         puts("");
      }
}
/*=============================
**     α׷
**===========================*/
void main(int argc,char *argv[])
{
int i,sw,mode;
  /*Уɣ ʱȭ*/
   TMset(); 
  outportb(PITC,PITinit);
  wait();
  outportb(PITD,0);
  wait();
   /*ø ̽ ʱȭ*/
#ifdef PC_98
   /*--- 8251 ʱȭ ---*/
  outportb(port_out_add,0); wait();
  outportb(port_out_add,0); wait();
  outportb(port_out_add,(regs=volt_plus)); wait();
#endif
#ifdef PC_AT
   /*--- 8250 ʱȭ ---*/
   outportb(RSport+4,(regs=volt_plus)); wait();
   outportb(RSport+3,0x03); wait();
   outportb(RSport+1,0x00); wait();
#endif
  /* ɼ  */
  mode=0;
  for(i=sw=0;i<argc;i++) {
    if(argv[i+1][0]=='/' || argv[i+1][0]=='-') {
      switch(toupper(argv[i+1][1])) {
      case 'T' : itime=atoi(argv[i+1]+2);
                 if(itime<10) sw=1;
                 break;
      case 'N' : count=atoi(argv[i+1]+2);
                 if(count<0) sw=1;
                 break;
      case 'M' : mode=atoi(argv[i+1]+2);
                 if(mode<0) sw=1;
                 break;
      case 'F' : strncpy(fname,argv[i+1]+2,30);
                 if(strlen(fname)<1) sw=1;
                 break;
      default  : sw=2;
      }
    }
  }
  if(sw) {
    if(sw==1) puts("Ķ "); 
    if(sw==2) {
      puts("usage : DS1820F [/t#] [/n#] [/fFileName] [/m#]");
      puts("         /t# : #=10-32000() ð(10)");
      puts("         /n# : #=1-32000(ȸ) ȸ(6)");
      puts("  /fFileName : ϸ(DS1820.OUT)");
    }
    exit(1);
  }
   switch(mode) {
  case 0 :/* */
    searchROM(0);
    sample();
    break;
  case 1 :/*read ROM command*/
    readROM();
    break;
  case 2 :/*search ROM command*/
    searchROM(1);
    break;
  }
}
