      PL  76
;********************************************************
;*                   *
;*    ROM(27C256) EMULATER for MC68HC11 *
;*                   *
;* 2000/ 9/ 5 RE_001.ASM       *
;*                   *
;* CPU:MC68HC11A0,A1            *
;* ROM:27C256  RAM:26C256      *
;********************************************************
;
;DATE    NO.      COMENT
;96/11/22  RE_000.ASM    ver1.0(BUAD=1/4)
;98/ 5/ 2  RE_001.ASM    ver1.0(FDEVICE Ͽ ڸƮ ߰ )
;
;
;***  ******
;TARGET SCI ̿Ͽ INTEL HEX (ASCII FILE) α׷
;ٿεϰ,  RAM(32KByte) ִ´.
;ٿε ϷĿ OK MSG ۽ , TARGET ڽſ  ϵ
;RESET(RESET Lo ) ϴ TARGET ROM ķƮѴ.
;
;۽ Ʈ Ÿ E_CLOCK 4  äϰ ,
;ϱ Ʈ ǥ ϰ ִ.
;
;XTAL      ֺ  Ʈ  PC Ʈ   
;9.8304MHz    4    38.4  Kbps  38.4 Kbps      (PC5/10MHz)
;8.0000MHz    4    31.25 Kbps  30.7 Kbps      
;4.9152MHz    4    19.2  Kbps  19.2 Kbps      (PC5/10MHz)
;4.0000MHz    4    15.625Kbps  15.36Kbps      
;
;췹Ʈ ô ϱ "BUAD_RATA"  , ٽ  
;
;  쿡  Ʈ  ̿ Ʈ 
;ϴ  "BPSCONV.EXE" Ͽ PC Ʈ 缳 ʿ䰡 ִ
;
; ķ   "RE_001.HLP" Ǵ ROM   ޴
; .(PC "H" KEY Է  ޴ ǥѴ)
;
;
; .GLOBALS ON
;**************************************************************
;   
;**************************************************************
BAUD_RATE  EQU   00000010B  ;1/4 9.8304MHz-->38.4Kbps
;
;BAUD_RATE EQU   00000001B  ;1/2 9.8304MHz-->76.8Kbps
;BAUD_RATE EQU   00000011B  ;1/8 9.8304MHz-->19.2Kbps
;
PORT_CONT  EQU   $6000    ;CONTROL ADR
WAIT_CONST EQU   614      ;CLOCK=0.8138usec
;
   EJECT
;**************************************************************
; 巹 
;**************************************************************
REG_BASE EQU  $1000    ;REG TOP ADR=$1000
PORT_A   EQU  REG_BASE+$00
PORT_D   EQU  REG_BASE+$08
DDR_D    EQU  REG_BASE+$09
PORT_E   EQU  REG_BASE+$0A
CFORC    EQU  REG_BASE+$0B
OCIM     EQU  REG_BASE+$0C
OCID     EQU  REG_BASE+$0D
TCNT     EQU  REG_BASE+$0E
TICI1    EQU  REG_BASE+$10
TICI2    EQU  REG_BASE+$12
TICI3    EQU  REG_BASE+$14
TOCI1    EQU  REG_BASE+$16
TOCI2    EQU  REG_BASE+$18
TOCI3    EQU  REG_BASE+$1A
TOCI4    EQU  REG_BASE+$1C
TOCI5    EQU  REG_BASE+$1E
TCTL1    EQU  REG_BASE+$20
TCTL2    EQU  REG_BASE+$21
TMASK1   EQU  REG_BASE+$22
TFLAG1   EQU  REG_BASE+$23
TMASK2   EQU  REG_BASE+$24
TFLAG2   EQU  REG_BASE+$25
PACTL    EQU  REG_BASE+$26
;
BAUD     EQU  REG_BASE+$2B
SCCR1    EQU  REG_BASE+$2C
SCCR2    EQU  REG_BASE+$2D
SCSR     EQU  REG_BASE+$2E
SCDR     EQU  REG_BASE+$2F
;
ADCTL    EQU  REG_BASE+$30
ADRD1    EQU  REG_BASE+$31
ADRD2    EQU  REG_BASE+$32
ADRD3    EQU  REG_BASE+$33
ADRD4    EQU  REG_BASE+$34
;
OPTION   EQU  REG_BASE+$39
COPROG   EQU  REG_BASE+$3A
PPROG    EQU  REG_BASE+$3B
HPRIO    EQU  REG_BASE+$3C
INIT     EQU  REG_BASE+$3D
CONFIG   EQU  REG_BASE+$3F
;**************************************************
   EJECT
;
   .PAGE0
;**************************************************************
;ң ũ (ROM EMULATE RAM)
;**************************************************************
CONT_BUF RMB  1     ;CONTROL BUF
RXBUF_CH RMB  1     ;RXBUF ä(0~1)
RX_BUF   RMB  2     ;RX_BUF
START_F RMB   1     ;Ű ÷(1=ON,0=OFF)
END_F    RMB  1     ; ÷(1=ON,0=OFF)
WRITE_F RMB   1     ;RAM ֱ OK ÷(1=ON,0=NG)
;
DAT_CH      RMB  1  ; ͹ ä(0~49)
DAT_BUF    RMB   50 ; ͹(50byte)
DATASU      RMB  1  ;HEX ۽ 1 DATA(MAX=32)
CHECK_SUM  RMB   1  ;üũ(0=OK,0<>NG)
;
RAM_ADR    RMB   2  ;ֱ RAM ADRESS
RAM_END    RMB   2  ;ֱ RAM END ADRESS

   EJECT
   .CODE
   ORG   $8000
;**************************************************************
;  α׷ ̴ϼȶ
;**************************************************************
P_TOP:
   SEI
   LDS   #$0FF   ;STACK SET
;
   LDX   #$0
   CLRA
?_CLR:
   STAA 0,X      ;RAM $0~$FF Ŭ
   INX
   CPX   #$0FF+1
   BLO   ?_CLR
;
   JSR   SET_SCI    ;BAUD SET
   CLI
   JSR   OPENING    ;OPENNING MSG ۽
   JSR   BEEP       ;ARALM

   EJECT
;**************************************************************
; α׷
;**************************************************************
LOOP:
   JSR   RX_READ    ;1byte о̱
;
   CMPA #"G"
   BNE   ?_0
   JMP   P_START    ;"G"-->PROG START
?_0:
   CMPA #":"        ;":"  ?
   BEQ   ?_INIT
;
   CMPA #$0D        ;"CR" -->CHECKSUM ˻
   BEQ   ?_CHECK
;
   CMPA #$0A        ;"LF"-->LOOP TOP
   BEQ   LOOP
;
   LDAB START_F     ;START_F=0 -->LOOP TOP
   BNE   ?_1
;
   CMPA #$48        ;"H" ?
   BNE   LOOP
   JSR   HELP_DISP
   BRA   LOOP
?_1:
   LDAB RXBUF_CH
   BNE   ?_2
;
   STAA RX_BUF      ;DATA-->BUF
   INC   RXBUF_CH
   BRA   LOOP
?_2:
   STAA RX_BUF+1
   CLR   RXBUF_CH
;
   LDD   RX_BUF
   JSR   COPY_DAT   ;CH=0~1 DATA INPUT-->BIN CONV
;
   LDAA END_F
   BNE   ?_END      ;END_F=1 -->END
;
   LDAA WRITE_F     ;WRITE_F CHECK
   BEQ   ?_3
;
   JSR   RAM_WRITE  ;DATA WRITE
   BRA   LOOP
?_3:
   LDAA DAT_CH
   CMPA #4
   BNE   ?_4
   JSR   ADR_SET    ;ADRESS SET
?_4:
   BRA   LOOP
?_CHECK:
   LDAA CHECK_SUM   ;CHECK SUM OK?
   BEQ   LOOP
?_NG:
   JSR   ERR_SEND ;ERR MSG SEND
?_ERRLP:
   JSR   BEEP    ;ERR BEEP
   JSR   WAIT_50
   JSR   BEEP
   JSR   WAIT_50
   JSR   BEEP
   BRA   ?_ERRLP    ;CHECK SUM NG -->BEEP LP
;
?_END:
   LDAA CONT_BUF
   ANDA #11111011B
   STAA CONT_BUF
   STAA PORT_CONT   ;WRITE LED OFF
;
   JSR   WAIT_50
   JSR   OK_SEND    :OK MSG SEND
   JMP   P_START    ;PROG START
?_INIT:
   JSR   READ_START
   JMP   LOOP    ;":" LOOP

   EJECT
;**************************************************************
;ȣţ    Ŭ ƾ
;**************************************************************
READ_START:
   CLRA
   STAA RXBUF_CH
   STAA CHECK_SUM
   STAA DAT_CH
   STAA WRITE_F
   STAA END_F
;
   LDAA #1
   STAA START_F     ;":" -> START_F=1 SET
;
   LDAA CONT_BUF
   EORA #00000100B ;WRITE LED 
   STAA CONT_BUF
   STAA PORT_CONT
   RTS
;**************************************************************
;   ң ֱ ƾ
; BINARY ȯ, DAT_BUF 
;**************************************************************
COPY_DAT:
   JSR   CONV_BIN   ;BIN ȯ
;
   LDX   #DAT_BUF
   LDAB DAT_CH
   ABX
   STAA 0,X         ;BIN DATA
;
   ADDA CHECK_SUM
   STAA CHECK_SUM   ;CHECK SUM
;
   INC   DAT_CH
   RTS
;**************************************************************
;ң ֱ 巹 Ʈ ƾ
;**************************************************************
ADR_SET:
   LDAA DAT_BUF
   BEQ   ?_END
;
   STAA DATASU      ;DATASU
   LDD   DAT_BUF+1
   STD   RAM_ADR    ;RAM WRITE TOP ADR
;
   CLRA
   LDAB DATASU
   DECB
   ADDD RAM_ADR
   STD   RAM_END    ;WRITE END ADR
;
   LDAA #1
   STAA WRITE_F
   RTS
?_END:
   CLR   WRITE_F
   LDAA #1
   STAA END_F       ;END_F SET
   RTS
;**************************************************************
;ң ֱ ƾ
; DAT_BUF ---->RAM WRITE
;**************************************************************
RAM_WRITE:
   LDY   RAM_ADR
   LDX   #DAT_BUF
   LDAB DAT_CH
   DECB
   ABX               ;DAT ADR
   LDAA 0,X
   STAA 0,Y
   INY
   BEQ   ?_0
   CPY   RAM_END
   BHI   ?_0
;
   STY   RAM_ADR    ;RAM WRITE ADR INC
   RTS
?_0:
   CLR   WRITE_F
   RTS
;**************************************************************
;£ţţй߻ ƾ
;**************************************************************
BEEP:
   LDAA CONT_BUF ;EXT HC175 BUF
   ORAA #00000010B ;BUZZER ON
   STAA CONT_BUF
   STAA PORT_CONT
;
   JSR   WAIT_100 ;100msec BEEP

   LDAA CONT_BUF ;EXT HC175 BUF
   ANDA #11111101B ;BUZZER OFF
   STAA CONT_BUF
   STAA PORT_CONT
   RTS
;**************************************************************
;α׷ ӣԣң ƾ
;**************************************************************
P_START:
   JSR   BEEP
   JSR   WAIT_50
   JSR   BEEP       ;BEEP ON*2
;
   LDX   #SWAP_DAT
   LDY   #$00D0     ;RAM 00D0~
?_0:
   LDAA 0,X
   STAA 0,Y
   INX
   INY
   CPX   #DAT_END
   BLO   ?_0
   JMP   $00D0      ;PROGRAM --> RAM Ͻ̵
SWAP_DAT:
   LDAA #00001001B ;ROM-->RAM CHANGE and CPU RESET
   STAA PORT_CONT
DAT_END:
;**************************************************************
; ǥ ƾ
;**************************************************************
OPENING:
   LDX   #MSG_OPENING
?_0:
   LDAA 0,X
   JSR   RS_SEND
   INX
   CPX   #MSG_OPENING+101
   BLS   ?_0
   RTS
;
MSG_OPENING:
   DB "CR","LF"
   DB "-","-","-"," ","R","O","M"," ","E","M","U","L","A","T","E","R"
   DB " ","f","o","r"," "
   DB "M","C","6","8","H","C","1","1"," "
   DB "(","9",".","8","3","0","4","M","H","z"," "
   DB "3","8",".","4","K","b","p","s",")"," "
   DB "9","6",".","1","1",".","2","2"," "
   DB "v","e","r","1",".","0"," "
   DB "b","y"," ","W","a","k","a"," ","-","-","-"
   DB "CR","LF"
   DB "CR","LF"
   DB "H","E","X"," ","D","A","T","A"," "
   DB "S","E","N","D"," ","O","K"
   DB "CR","LF"
;**************************************************************
; ϣ ǥ ƾ
;**************************************************************
OK_SEND:
   LDX   #MSG_OK
?_0:
   LDAA 0,X
   JSR   RS_SEND    ;OK MSG ۽
   INX
   CPX   #MSG_OK+34
   BLS   ?_0
   RTS
;
MSG_OK:
   DB "CR","LF"
   DB "D","A","T","A"," ","R","E","A","D"," ","O","K"
   DB " ","-","-","-",">"," "
   DB "E","M","U","L","A","T","E"," ","S","T","A","R","T"
   DB "CR","LF"
;**************************************************************
;  ǥ ƾ
;**************************************************************
ERR_SEND:
   LDAA #"CR"
   JSR   RS_SEND
   LDAA #"LF"
   JSR   RS_SEND
;
   LDAA DAT_BUF+1
   JSR   RS_OUTB
   LDAA DAT_BUF+2
   JSR   RS_OUTB    ;NG ADRESS ۽
   LDAA #" "
   JSR   RS_SEND
;
   LDX   #MSG_ERR
?_0:
   LDAA 0,X
   JSR   RS_SEND    ;NG MSG ۽
   INX
   CPX   #MSG_ERR+17
   BLS   ?_0
   RTS
;
MSG_ERR:
   DB "H","E","X"," ","D","A","T","A"," "
   DB "R","E","A","D"," ","N","G"
   DB "CR","LF"
;**************************************************************
;ӣã ̴ϼȶ ƾ
;**************************************************************
SET_SCI:
   LDAA #BAUD_RATE
   STAA BAUD     ;BAUD SET
;
   LDAA #00000000B
   STAA SCCR1       ;DATA=8bit,START=STOP=1bit
;
   JSR   RXBUF_CLR
;
   LDAA #00001100B ;TE=1 (TIE,TCIE,RIE,ILIE,TE,RE,RWU,SBK)
   STAA SCCR2       ;۽,  ̳̺
   RTS
;**************************************************************
;ӣã   Ŭ ƾ
;**************************************************************
RXBUF_CLR:          ;RX_BUF 0~1 CLEAR
   LDD   #0
   STAB RXBUF_CH
   STAB RX_BUF
   STAB CHECK_SUM   ;CHECK SUM CLR
;
   STAB START_F
   STAB WRITE_F
   STAB END_F
   STAB DAT_CH
   LDX   #DAT_BUF
?_LOOP:
   STD   0,X         ;DAT_BUF CLR
   INX
   INX
   CPX   #DAT_BUF+49
   BLS   ?_LOOP
   RTS
;**************************************************************
;  о̱ ƾ
;**************************************************************
RX_READ:
   LDAA SCSR
   ANDA #00100000B ;RDRF üũ
   BEQ   RX_READ
;
   LDAA SCDR        ;1byte о̱
   RTS
;**************************************************************
;ӣãɣ -->̳ʸ ȯ ƾ
;   ASCII A,B 2byte set -->A 1byte(BIN)
;**************************************************************
CONV_BIN:
   SUBA #$30
   CMPA #9
   BLS   ?_0
   SUBA #7        ;A~F
?_0:
   LSLA
   LSLA
   LSLA
   LSLA           ; 4bit Լ
   SUBB #$30
   CMPB #9
   BLS   ?_1
   SUBB #7        ;A~F
?_1:
   ABA            ;A<--1byte(BIN)
   RTS
**************************************************************
;̳ʸ -->ӣãɣ ȯ ƾ
; (--> 4bitASC-->A,4bitASC-->B)
;**************************************************************
CONV_ASC:
   TAB
   ANDA #$F0        ; 4bit Լ
   LSRA
   LSRA
   LSRA
   LSRA
   CMPA #09
   BLS   ?_1
   ADDA #07         ;A~F
?_1:
   ADDA #$30        ; 4bit-->ASC
;
   ANDB #$0F
   CMPB #09
   BLS   ?_2
   ADDB #07
?_2:
   ADDB #$30        ;4bit-->ASC
   RTS
;**************************************************************
;ңӣ ۽( ۽ ͸ Ʈ)
;**************************************************************
RS_SEND:
   PSHB
?_0:
   LDAB SCSR        ;ƮƮ ̳̺ üũ
   ANDB #01000000B ;TDRE CHECK
   BEQ   ?_0
;
   STAA SCDR        ;1byte ۽
   PULB
   RTS
;**************************************************************
;   ƽŰ ۽ ƾ
; A->۽ 
;**************************************************************
RS_OUTB:
   JSR   CONV_ASC
   JSR   RS_SEND
   TBA
   JSR   RS_SEND
   RTS
;***********************************************************
;Ÿ̹ Ʈ ƾ(1msec~1000msec)
;***********************************************************
WAIT_1:             ;1msec WAIT
   PSHX
   LDX   #WAIT_CONST/10
   BRA   WAIT_LOOP
;
WAIT_5:             ;5msec WAIT
   PSHX
   LDX   #WAIT_CONST/2
   BRA   WAIT_LOOP
;
WAIT_10:         ;10msec WAIT
   PSHX
   LDX   #WAIT_CONST
   BRA   WAIT_LOOP
;
WAIT_50:         ;50msec WAIT
   PSHX
   LDX   #WAIT_CONST*5
   BRA   WAIT_LOOP
;
WAIT_100:        ;100msec WAIT
   PSHX
   LDX   #WAIT_CONST*10
   BRA   WAIT_LOOP
;
WAIT_200:        ;200msec WAIT
   PSHX
   LDX   #WAIT_CONST*20
   BRA   WAIT_LOOP
;
WAIT_500:        ;500msec WAIT
   PSHX
   LDX   #WAIT_CONST*50
   BRA   WAIT_LOOP
;
WAIT_1000:       ;1000msec WAIT
   JSR   WAIT_500
   JSR   WAIT_500
   RTS
;
WAIT_2000:       ;2000msec WAIT
   JSR   WAIT_1000
   JSR   WAIT_1000
   RTS
;
WAIT_LOOP:       ;LOOP SUM = 20 cycle)
   NOP
   NOP
   NOP
   NOP
   NOP
   NOP
   NOP
   DEX
   BNE  WAIT_LOOP
;
   PULX
   RTS
;**************************************************************
; ͣӣ ǥ ƾ
;**************************************************************
HELP_DISP:
   LDX   #MSG_HELP
?_0:
   LDAA 0,X
   JSR   RS_SEND    ;HELP MSG ۽
   INX
   CPX   #HELP_END
   BLS   ?_0
   RTS
MSG_HELP:  ;HELP MSGࣴˣ£-->"RE_001.HLP" DUMP DAT
   DB $0D,$0A,$09,$2A,$2A,$2A,$2A,$2A,$2A,$2A,$20,$83,$77,$83,$8B,$83
   DB $76,$83,$81,$83,$6A,$83,$85,$20,$50,$43,$39,$38,$20,$76,$65,$72
   DB $31,$2E,$30,$20,$39,$36,$2F,$31,$31,$2F,$32,$32,$20,$2A,$2A,$2A
   DB $2A,$2A,$2A,$0D,$0A,$0D,$0A,$09,$31,$2E,$91,$CE,$89,$9E,$83,$5E
   DB $81,$5B,$83,$51,$83,$62,$83,$67,$83,$7B,$81,$5B,$83,$68,$0D,$0A
   DB $09,$82,$62,$82,$6F,$82,$74,$81,$69,$82,$6C,$82,$62,$82,$55,$82
   DB $57,$82,$67,$82,$62,$82,$50,$82,$50,$81,$6A,$81,$7B,$8A,$4F,$95
   DB $74,$82,$AF,$82,$71,$82,$6E,$82,$6C,$81,$69,$82,$51,$82,$56,$82
   DB $51,$82,$54,$82,$55,$81,$6A,$8D,$5C,$90,$AC,$0D,$0A,$09,$82,$CC
   DB $8F,$AC,$8B,$4B,$96,$CD,$83,$7B,$81,$5B,$83,$68,$81,$42,$0D,$0A
   DB $09,$83,$5E,$81,$5B,$83,$51,$83,$62,$83,$67,$82,$CC,$82,$71,$82
   DB $6E,$82,$6C,$83,$41,$83,$68,$83,$8C,$83,$58,$82,$CD,$81,$90,$82
   DB $57,$82,$4F,$82,$4F,$82,$4F,$81,$60,$81,$90,$82,$65,$82,$65,$82
   DB $65,$82,$65,$8C,$C5,$92,$E8,$81,$42,$0D,$0A,$0D,$0A,$0D,$0A,$09
   DB $32,$2E,$90,$DA,$91,$B1,$95,$FB,$96,$40,$0D,$0A,$09,$83,$5E,$81
   DB $5B,$83,$51,$83,$62,$83,$67,$82,$71,$82,$6E,$82,$6C,$83,$5C,$83
   DB $50,$83,$62,$83,$67,$82,$C9,$82,$71,$82,$6E,$82,$6C,$83,$76,$83
   DB $8D,$81,$7C,$83,$75,$81,$69,$82,$51,$82,$57,$82,$6F,$81,$6A,$82
   DB $C6,$89,$BA,$8B,$4C,$82,$CC,$0D,$0A,$81,$40,$81,$40,$81,$40,$81
   DB $40,$83,$8F,$83,$6A,$83,$4F,$83,$60,$83,$4E,$83,$8A,$83,$62,$83
   DB $76,$81,$69,$82,$53,$96,$7B,$81,$6A,$82,$F0,$83,$52,$83,$93,$83
   DB $67,$83,$8D,$81,$5B,$83,$8B,$90,$4D,$8D,$86,$82,$C6,$90,$DA,$91
   DB $B1,$82,$B7,$82,$E9,$82,$B1,$82,$C6,$81,$42,$0D,$0A,$0D,$0A,$09
   DB $09,$83,$8F,$83,$6A,$83,$4F,$83,$60,$83,$4E,$83,$8A,$83,$62,$83
   DB $76,$81,$69,$97,$CE,$81,$6A,$20,$2D,$2D,$3E,$20,$82,$64,$83,$4E
   DB $83,$8D,$83,$62,$83,$4E,$0D,$0A,$09,$09,$83,$8F,$83,$6A,$83,$4F
   DB $83,$60,$83,$4E,$83,$8A,$83,$62,$83,$76,$81,$69,$89,$A9,$81,$6A
   DB $20,$2D,$2D,$3E,$20,$82,$71,$81,$5E,$82,$76,$0D,$0A,$09,$09,$83
   DB $8F,$83,$6A,$83,$4F,$83,$60,$83,$4E,$83,$8A,$83,$62,$83,$76,$81
   DB $69,$94,$92,$81,$6A,$20,$2D,$2D,$3E,$20,$82,$60,$82,$50,$82,$54
   DB $0D,$0A,$09,$09,$83,$8F,$83,$6A,$83,$4F,$83,$60,$83,$4E,$83,$8A
   DB $83,$62,$83,$76,$81,$69,$90,$C2,$81,$6A,$20,$2D,$2D,$3E,$20,$82
   DB $71,$82,$64,$82,$72,$82,$64,$82,$73,$0D,$0A,$0D,$0A,$09,$83,$5E
   DB $81,$5B,$83,$51,$83,$62,$83,$67,$82,$62,$82,$6F,$82,$74,$82,$CC
   DB $82,$72,$82,$62,$82,$68,$8B,$40,$94,$5C,$82,$F0,$97,$98,$97,$70
   DB $82,$B5,$82,$C4,$82,$A2,$82,$E9,$88,$D7,$81,$41,$83,$5E,$81,$5B
   DB $83,$51,$83,$62,$83,$67,$82,$CC,$0D,$0A,$09,$52,$78,$5F,$44,$2C
   DB $54,$78,$5F,$44,$2C,$47,$4E,$44,$82,$F0,$CF,$B7,$BC,$CF,$32,$33
   DB $32,$43,$93,$99,$82,$C5,$83,$8C,$83,$78,$83,$8B,$95,$CF,$8A,$B7
   DB $82,$B5,$82,$6F,$82,$62,$82,$CC,$82,$71,$82,$72,$82,$51,$82,$52
   DB $82,$51,$82,$62,$82,$C6,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40
   DB $90,$DA,$91,$B1,$82,$B7,$82,$E9,$82,$B1,$82,$C6,$81,$42,$0D,$0A
   DB $0D,$0A,$09,$93,$64,$8C,$B9,$82,$CD,$83,$5E,$81,$5B,$83,$51,$83
   DB $62,$83,$67,$82,$E6,$82,$E8,$8B,$9F,$8B,$8B,$82,$B3,$82,$EA,$82
   DB $E9,$88,$D7,$95,$73,$97,$76,$81,$42,$0D,$0A,$09,$83,$47,$83,$7E
   DB $83,$85,$83,$8C,$81,$5B,$83,$5E,$93,$E0,$91,$A0,$82,$CC,$83,$6F
   DB $83,$62,$83,$65,$83,$8A,$82,$CD,$8F,$ED,$8E,$9E,$83,$67,$83,$8A
   DB $83,$4E,$83,$8B,$8F,$5B,$93,$64,$82,$B3,$82,$EA,$82,$C4,$82,$A8
   DB $82,$E8,$83,$6F,$83,$62,$83,$4E,$0D,$0A,$09,$83,$41,$83,$62,$83
   DB $76,$82,$72,$82,$76,$82,$F0,$82,$6E,$82,$6D,$82,$C9,$82,$B7,$82
   DB $E9,$82,$B1,$82,$C6,$82,$C9,$82,$E6,$82,$E8,$82,$51,$82,$4F,$82
   DB $67,$82,$92,$91,$4F,$8C,$E3,$82,$CC,$82,$71,$82,$60,$82,$6C,$83
   DB $6F,$83,$62,$83,$4E,$83,$41,$0D,$0A,$09,$83,$62,$83,$76,$89,$C2
   DB $94,$5C,$81,$42,$0D,$0A,$0D,$0A,$0D,$0A,$09,$33,$2E,$92,$CA,$90
   DB $4D,$95,$FB,$96,$40,$0D,$0A,$09,$83,$76,$83,$8D,$83,$67,$83,$52
   DB $83,$8B,$82,$CD,$89,$BA,$8B,$4C,$82,$CC,$82,$C6,$82,$A8,$82,$E8
   DB $0D,$0A,$0D,$0A,$09,$94,$F1,$93,$AF,$8A,$FA,$81,$69,$92,$B2,$95
   DB $E0,$93,$AF,$8A,$FA,$81,$6A,$92,$CA,$90,$4D,$0D,$0A,$09,$44,$41
   DB $54,$41,$3D,$38,$62,$69,$74,$2C,$53,$54,$41,$52,$54,$3D,$31,$62
   DB $69,$74,$2C,$53,$54,$4F,$50,$3D,$31,$62,$69,$74,$2C,$50,$41,$52
   DB $49,$54,$59,$3D,$4F,$46,$46,$2C,$58,$4F,$4E,$2F,$4F,$46,$46,$3D
   DB $4F,$46,$46,$0D,$0A,$0D,$0A,$09,$92,$CA,$90,$4D,$83,$7B,$81,$5B
   DB $83,$8C,$81,$5B,$83,$67,$82,$CD,$83,$5E,$81,$5B,$83,$51,$83,$62
   DB $83,$67,$82,$CC,$45,$5F,$43,$4C,$4F,$43,$4B,$82,$F0,$34,$95,$AA
   DB $8E,$FC,$82,$B5,$82,$BD,$82,$E0,$82,$CC,$82,$F0,$8D,$CC,$97,$70
   DB $82,$B5,$82,$C4,$0D,$0A,$09,$82,$A8,$82,$E8,$81,$41,$89,$BA,$8B
   DB $4C,$83,$7B,$81,$5B,$83,$8C,$81,$5B,$83,$67,$82,$F0,$95,$57,$8F
   DB $80,$82,$C6,$82,$B5,$82,$C4,$82,$A2,$82,$E9,$81,$42,$0D,$0A,$0D
   DB $0A,$20,$20,$20,$20,$20,$20,$20,$20,$20,$58,$54,$41,$4C,$20,$20
   DB $20,$20,$20,$20,$95,$AA,$8E,$FC,$94,$E4,$20,$20,$CE,$DE,$B0,$DA
   DB $B0,$C4,$09,$50,$43,$91,$A4,$CE,$DE,$B0,$DA,$B0,$C4,$20,$20,$20
   DB $92,$CA,$90,$4D,$0D,$0A,$20,$20,$20,$20,$20,$20,$20,$20,$20,$39
   DB $2E,$38,$33,$30,$34,$4D,$48,$7A,$20,$20,$20,$20,$34,$20,$20,$20
   DB $20,$33,$38,$2E,$34,$20,$20,$4B,$62,$70,$73,$09,$20,$33,$38,$2E
   DB $34,$20,$4B,$62,$70,$73,$20,$20,$20,$20,$81,$9B,$28,$50,$43,$35
   DB $2F,$31,$30,$4D,$48,$7A,$82,$CC,$82,$DD,$29,$0D,$0A,$20,$20,$20
   DB $20,$20,$20,$20,$20,$20,$38,$2E,$30,$30,$30,$30,$4D,$48,$7A,$20
   DB $20,$20,$20,$34,$20,$20,$20,$20,$33,$31,$2E,$32,$35,$20,$4B,$62
   DB $70,$73,$09,$20,$33,$30,$2E,$37,$20,$4B,$62,$70,$73,$20,$20,$20
   DB $20,$81,$9B,$0D,$0A,$20,$20,$20,$20,$20,$20,$20,$20,$20,$34,$2E
   DB $39,$31,$35,$32,$4D,$48,$7A,$20,$20,$20,$20,$34,$20,$20,$20,$20
   DB $31,$39,$2E,$32,$20,$20,$4B,$62,$70,$73,$09,$20,$31,$39,$2E,$32
   DB $20,$4B,$62,$70,$73,$20,$20,$20,$20,$81,$9B,$28,$50,$43,$35,$2F
   DB $31,$30,$4D,$48,$7A,$82,$CC,$82,$DD,$29,$0D,$0A,$20,$20,$20,$20
   DB $20,$20,$20,$20,$20,$34,$2E,$30,$30,$30,$30,$4D,$48,$7A,$20,$20
   DB $20,$20,$34,$20,$20,$20,$20,$31,$35,$2E,$36,$32,$35,$4B,$62,$70
   DB $73,$09,$20,$31,$35,$2E,$33,$36,$4B,$62,$70,$73,$20,$20,$20,$20
   DB $81,$9B,$0D,$0A,$0D,$0A,$0D,$0A,$09,$82,$6F,$82,$62,$82,$AA,$39
   DB $35,$32,$31,$41,$66,$88,$C8,$8D,$7E,$82,$C9,$8C,$C0,$92,$E8,$82
   DB $B3,$82,$EA,$82,$E9,$8F,$EA,$8D,$87,$82,$CD,$82,$71,$82,$6E,$82
   DB $6C,$83,$47,$83,$7E,$83,$85,$83,$8C,$81,$5B,$83,$5E,$93,$E0,$82
   DB $CC,$83,$75,$81,$5B,$83,$67,$0D,$0A,$09,$83,$8D,$81,$5B,$83,$68
   DB $82,$71,$82,$6E,$82,$6C,$82,$CC,$42,$41,$55,$44,$95,$AA,$8E,$FC
   DB $94,$E4,$82,$F0,$95,$CF,$8D,$58,$28,$34,$2D,$3E,$32,$29,$82,$B5
   DB $89,$BA,$8B,$4C,$83,$7B,$81,$5B,$83,$8C,$81,$5B,$83,$67,$82,$F0
   DB $95,$57,$8F,$80,$82,$C6,$82,$B5,$0D,$0A,$09,$82,$BD,$82,$D9,$82
   DB $A4,$82,$AA,$8D,$82,$91,$AC,$82,$C5,$82,$E6,$82,$A2,$82,$A9,$82
   DB $E0,$81,$42,$81,$69,$92,$41,$82,$B5,$8E,$C0,$8D,$DB,$82,$C9,$8A
   DB $6D,$94,$46,$82,$CD,$82,$B5,$82,$C4,$82,$A2,$82,$C8,$82,$A2,$81
   DB $6A,$0D,$0A,$0D,$0A,$20,$20,$20,$20,$20,$20,$20,$20,$20,$58,$54
   DB $41,$4C,$20,$20,$20,$20,$20,$20,$95,$AA,$8E,$FC,$94,$E4,$20,$20
   DB $CE,$DE,$B0,$DA,$B0,$C4,$09,$50,$43,$91,$A4,$CE,$DE,$B0,$DA,$B0
   DB $C4,$20,$20,$20,$92,$CA,$90,$4D,$0D,$0A,$20,$20,$20,$20,$20,$20
   DB $20,$20,$20,$39,$2E,$38,$33,$30,$34,$4D,$48,$7A,$20,$20,$20,$20
   DB $32,$20,$20,$20,$20,$37,$36,$2E,$38,$20,$20,$4B,$62,$70,$73,$09
   DB $20,$20,$37,$36,$2E,$38,$4B,$62,$70,$73,$20,$20,$20,$20,$96,$A2
   DB $8A,$6D,$94,$46,$81,$69,$91,$BD,$95,$AA,$81,$9B,$81,$6A,$0D,$0A
   DB $20,$20,$20,$20,$20,$20,$20,$20,$20,$38,$2E,$30,$30,$30,$30,$4D
   DB $48,$7A,$20,$20,$20,$20,$32,$20,$20,$20,$20,$36,$32,$2E,$35,$20
   DB $20,$4B,$62,$70,$73,$09,$20,$20,$36,$31,$2E,$34,$4B,$62,$70,$73
   DB $20,$20,$20,$20,$96,$A2,$8A,$6D,$94,$46,$81,$69,$91,$BD,$95,$AA
   DB $81,$9B,$81,$6A,$0D,$0A,$20,$20,$20,$20,$20,$20,$20,$20,$20,$34
   DB $2E,$39,$31,$35,$32,$4D,$48,$7A,$20,$20,$20,$20,$32,$20,$20,$20
   DB $20,$33,$38,$2E,$34,$20,$20,$4B,$62,$70,$73,$09,$20,$20,$33,$38
   DB $2E,$34,$4B,$62,$70,$73,$20,$20,$20,$20,$96,$A2,$8A,$6D,$94,$46
   DB $81,$69,$91,$BD,$95,$AA,$81,$9B,$81,$6A,$0D,$0A,$20,$20,$20,$20
   DB $20,$20,$20,$20,$20,$34,$2E,$30,$30,$30,$30,$4D,$48,$7A,$20,$20
   DB $20,$20,$32,$20,$20,$20,$20,$33,$31,$2E,$32,$35,$20,$4B,$62,$70
   DB $73,$09,$20,$20,$33,$30,$2E,$37,$4B,$62,$70,$73,$20,$20,$20,$20
   DB $96,$A2,$8A,$6D,$94,$46,$81,$69,$91,$BD,$95,$AA,$81,$9B,$81,$6A
   DB $0D,$0A,$0D,$0A,$0D,$0A,$09,$8F,$E3,$8B,$4C,$81,$41,$82,$A2,$82
   DB $B8,$82,$EA,$82,$CC,$8F,$EA,$8D,$87,$82,$C5,$82,$E0,$81,$41,$92
   DB $CA,$90,$4D,$83,$5C,$83,$74,$83,$67,$82,$CC,$83,$54,$83,$7C,$81
   DB $5B,$83,$67,$8A,$4F,$82,$CC,$83,$7B,$81,$5B,$83,$8C,$81,$5B,$83
   DB $67,$82,$C5,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$92,$CA,$90
   DB $4D,$82,$B7,$82,$E9,$8F,$EA,$8D,$87,$82,$CD,$42,$50,$53,$43,$4F
   DB $4E,$56,$2E,$45,$58,$45,$82,$AA,$95,$4B,$97,$76,$81,$42,$0D,$0A
   DB $0D,$0A,$0D,$0A,$0D,$0A,$09,$34,$2E,$8E,$67,$97,$70,$95,$FB,$96
   DB $40,$81,$69,$82,$BB,$82,$CC,$82,$50,$81,$6A,$0D,$0A,$09,$82,$6F
   DB $82,$62,$82,$C5,$82,$62,$82,$62,$82,$73,$81,$7C,$82,$58,$82,$57
   DB $93,$99,$82,$CC,$92,$CA,$90,$4D,$83,$5C,$83,$74,$83,$67,$82,$F0
   DB $8B,$4E,$93,$AE,$82,$B3,$82,$B9,$8E,$77,$92,$E8,$82,$CC,$83,$76
   DB $83,$8D,$83,$67,$83,$52,$83,$8B,$82,$C9,$0D,$0A,$09,$90,$DD,$92
   DB $E8,$82,$B7,$82,$E9,$81,$42,$0D,$0A,$0D,$0A,$09,$92,$CA,$90,$4D
   DB $83,$5C,$83,$74,$83,$67,$82,$CC,$83,$54,$83,$7C,$81,$5B,$83,$67
   DB $8A,$4F,$82,$CC,$83,$7B,$81,$5B,$83,$8C,$81,$5B,$83,$67,$82,$C5
   DB $92,$CA,$90,$4D,$82,$B7,$82,$E9,$8F,$EA,$8D,$87,$82,$CD,$92,$CA
   DB $90,$4D,$83,$5C,$83,$74,$83,$67,$0D,$0A,$09,$82,$CC,$8F,$AC,$83
   DB $76,$83,$8D,$83,$5A,$83,$58,$93,$E0,$82,$A9,$82,$E7,$22,$42,$50
   DB $53,$43,$4F,$4E,$56,$2E,$45,$58,$45,$22,$82,$F0,$8E,$C0,$8D,$73
   DB $82,$B5,$81,$41,$83,$7B,$81,$5B,$83,$8C,$81,$5B,$83,$67,$82,$F0
   DB $8D,$C4,$90,$DD,$92,$E8,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40
   DB $82,$B5,$92,$BC,$82,$B7,$82,$B1,$82,$C6,$81,$42,$0D,$0A,$0D,$0A
   DB $09,$93,$64,$8C,$B9,$82,$6E,$82,$6D,$82,$C5,$83,$41,$83,$89,$81
   DB $5B,$83,$80,$82,$AA,$94,$AD,$90,$B6,$82,$B5,$81,$41,$8B,$4E,$93
   DB $AE,$83,$5E,$83,$43,$83,$67,$83,$8B,$82,$AA,$95,$5C,$8E,$A6,$82
   DB $B3,$82,$EA,$82,$E9,$82,$B1,$82,$C6,$82,$F0,$8A,$6D,$0D,$0A,$81
   DB $40,$81,$40,$81,$40,$81,$40,$94,$46,$82,$B7,$82,$E9,$82,$B1,$82
   DB $C6,$81,$42,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$8B,$4E,$93
   DB $AE,$83,$81,$83,$6A,$83,$85,$81,$5B,$82,$AA,$95,$5C,$8E,$A6,$82
   DB $B3,$82,$EA,$82,$EA,$82,$CE,$8C,$8B,$90,$FC,$82,$CD,$82,$6E,$82
   DB $6A,$0D,$0A,$0D,$0A,$09,$82,$BB,$82,$CC,$8C,$E3,$81,$41,$83,$76
   DB $83,$8D,$83,$4F,$83,$89,$83,$80,$83,$66,$81,$5B,$83,$5E,$28,$49
   DB $4E,$54,$45,$4C,$20,$48,$45,$58,$8C,$60,$8E,$AE,$29,$82,$F0,$93
   DB $5D,$91,$97,$82,$B7,$82,$E9,$81,$42,$0D,$0A,$0D,$0A,$09,$83,$5F
   DB $83,$45,$83,$93,$83,$8D,$81,$5B,$83,$68,$92,$86,$82,$CD,$83,$89
   DB $83,$43,$83,$67,$82,$6B,$82,$64,$82,$63,$81,$69,$4C,$45,$44,$32
   DB $81,$6A,$82,$AA,$93,$5F,$96,$C5,$82,$B7,$82,$E9,$81,$42,$0D,$0A
   DB $81,$40,$81,$40,$81,$40,$81,$40,$93,$5D,$91,$97,$83,$8C,$81,$5B
   DB $83,$67,$82,$AA,$33,$30,$4B,$42,$50,$53,$88,$C8,$8F,$E3,$82,$CC
   DB $8F,$EA,$8D,$87,$82,$CD,$93,$F7,$8A,$E1,$82,$C5,$82,$CD,$93,$5F
   DB $96,$C5,$82,$AA,$8A,$6D,$94,$46,$8F,$6F,$97,$88,$82,$C8,$82,$A2
   DB $82,$A9,$82,$E0,$81,$48,$0D,$0A,$0D,$0A,$81,$40,$09,$92,$8D,$81
   DB $6A,$83,$76,$83,$8D,$83,$4F,$83,$89,$83,$80,$83,$5F,$83,$45,$83
   DB $93,$83,$8D,$81,$5B,$83,$68,$92,$86,$82,$CD,$83,$66,$81,$5B,$83
   DB $5E,$82,$CC,$83,$60,$83,$46,$83,$62,$83,$4E,$83,$54,$83,$80,$8A
   DB $6D,$94,$46,$82,$AA,$82,$50,$8D,$73,$96,$88,$0D,$0A,$81,$40,$81
   DB $40,$81,$40,$81,$40,$81,$40,$81,$40,$82,$C9,$8D,$73,$82,$ED,$82
   DB $EA,$82,$C4,$82,$A8,$82,$E8,$83,$60,$83,$46,$83,$62,$83,$4E,$83
   DB $54,$83,$80,$82,$6D,$82,$66,$82,$CC,$8F,$EA,$8D,$87,$82,$CD,$81
   DB $41,$83,$41,$83,$89,$81,$5B,$83,$80,$82,$F0,$94,$AD,$90,$B6,$82
   DB $B3,$82,$B9,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$81,$40,$81
   DB $40,$83,$47,$83,$89,$81,$5B,$82,$AA,$94,$AD,$90,$B6,$82,$B5,$82
   DB $BD,$8D,$73,$83,$41,$83,$68,$83,$8C,$83,$58,$82,$F0,$82,$6F,$82
   DB $62,$91,$A4,$82,$C9,$95,$5C,$8E,$A6,$82,$B7,$82,$E9,$81,$42,$0D
   DB $0A,$0D,$0A,$09,$93,$5D,$91,$97,$82,$AA,$8A,$AE,$97,$B9,$82,$B7
   DB $82,$EA,$82,$CE,$81,$41,$83,$89,$83,$43,$83,$67,$82,$6B,$82,$64
   DB $82,$63,$81,$69,$4C,$45,$44,$32,$81,$6A,$82,$AA,$8F,$C1,$93,$94
   DB $82,$B5,$81,$41,$83,$41,$83,$89,$81,$5B,$83,$80,$82,$F0,$82,$51
   DB $89,$F1,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$94,$AD,$90,$B6
   DB $82,$B5,$83,$47,$83,$7E,$83,$85,$83,$8C,$81,$5B,$83,$67,$82,$6B
   DB $82,$64,$82,$63,$81,$69,$4C,$45,$44,$31,$81,$6A,$82,$AA,$93,$5F
   DB $93,$94,$82,$B5,$81,$41,$93,$5D,$91,$97,$8A,$AE,$97,$B9,$83,$81
   DB $83,$62,$83,$5A,$81,$5B,$83,$57,$82,$F0,$0D,$0A,$81,$40,$81,$40
   DB $81,$40,$81,$40,$95,$5C,$8E,$A6,$82,$B7,$82,$E9,$81,$42,$0D,$0A
   DB $0D,$0A,$09,$82,$BB,$82,$CC,$8C,$E3,$83,$5E,$81,$5B,$83,$51,$83
   DB $62,$83,$67,$82,$62,$82,$6F,$82,$74,$82,$C9,$8B,$AD,$90,$A7,$93
   DB $49,$82,$C9,$52,$45,$53,$45,$54,$82,$F0,$82,$A9,$82,$AF,$81,$41
   DB $82,$71,$82,$6E,$82,$6C,$82,$F0,$83,$47,$83,$7E,$83,$85,$83,$8C
   DB $81,$5B,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$83,$67,$82,$B7
   DB $82,$E9,$81,$42,$0D,$0A,$0D,$0A,$09,$34,$2E,$8E,$67,$97,$70,$95
   DB $FB,$96,$40,$81,$69,$82,$BB,$82,$CC,$82,$51,$81,$6A,$0D,$0A,$09
   DB $82,$71,$82,$60,$82,$6C,$82,$CC,$83,$6F,$83,$62,$83,$4E,$83,$41
   DB $83,$62,$83,$76,$8F,$F3,$91,$D4,$82,$A9,$82,$E7,$82,$CD,$81,$41
   DB $82,$6F,$82,$62,$82,$E6,$82,$E8,$22,$47,$22,$20,$4B,$45,$59,$93
   DB $FC,$97,$CD,$82,$CC,$82,$DD,$82,$C5,$83,$5E,$81,$5B,$83,$51,$0D
   DB $0A,$81,$40,$81,$40,$81,$40,$81,$40,$83,$62,$83,$67,$82,$62,$82
   DB $6F,$82,$74,$82,$C9,$52,$45,$53,$45,$54,$82,$F0,$82,$A9,$82,$AF
   DB $81,$41,$91,$A6,$82,$71,$82,$6E,$82,$6C,$83,$47,$83,$7E,$83,$85
   DB $83,$8C,$81,$5B,$83,$67,$82,$AA,$89,$C2,$94,$5C,$81,$42,$0D,$0A
   DB $0D,$0A,$09,$8E,$67,$97,$70,$95,$FB,$96,$40,$93,$99,$82,$AA,$95
   DB $73,$96,$BE,$82,$CC,$8F,$EA,$8D,$87,$82,$CD,$82,$6F,$82,$62,$82
   DB $E6,$82,$E8,$22,$48,$22,$81,$69,$48,$45,$4C,$50,$81,$6A,$20,$4B
   DB $45,$59,$93,$FC,$97,$CD,$82,$C5,$96,$7B,$83,$77,$83,$8B,$83,$76
   DB $83,$81,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$83,$6A,$83,$85
   DB $82,$F0,$82,$6F,$82,$62,$91,$A4,$82,$C9,$91,$97,$90,$4D,$82,$B7
   DB $82,$E9,$81,$42,$0D,$0A,$0D,$0A,$09,$83,$47,$83,$7E,$83,$85,$83
   DB $8C,$81,$5B,$83,$67,$8C,$E3,$82,$CC,$83,$76,$83,$8D,$83,$4F,$83
   DB $89,$83,$80,$8D,$C4,$83,$5F,$83,$45,$83,$93,$83,$8D,$81,$5B,$83
   DB $68,$8E,$9E,$82,$CD,$93,$64,$8C,$B9,$4F,$46,$46,$82,$C9,$82,$B5
   DB $82,$C4,$83,$5E,$81,$5B,$83,$51,$0D,$0A,$81,$40,$81,$40,$81,$40
   DB $81,$40,$83,$62,$83,$67,$82,$F0,$8D,$C4,$8B,$4E,$93,$AE,$82,$B7
   DB $82,$E9,$82,$B1,$82,$C6,$82,$C5,$89,$C2,$94,$5C,$82,$C6,$82,$C8
   DB $82,$E9,$81,$42,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$82,$DC
   DB $82,$BD,$82,$CD,$81,$41,$83,$66,$83,$6F,$83,$62,$83,$4F,$83,$82
   DB $83,$6A,$83,$5E,$81,$5B,$82,$AA,$93,$5D,$91,$97,$82,$B3,$82,$EA
   DB $82,$C4,$82,$A2,$82,$E9,$8F,$F3,$91,$D4,$82,$C8,$82,$E7,$82,$CE
   DB $83,$5E,$81,$5B,$83,$51,$83,$62,$83,$67,$82,$62,$82,$6F,$0D,$0A
   DB $81,$40,$81,$40,$81,$40,$81,$40,$82,$74,$82,$CC,$52,$4F,$4D,$3C
   DB $2D,$3E,$52,$41,$4D,$90,$D8,$82,$E8,$8A,$B7,$82,$A6,$50,$4F,$52
   DB $54,$83,$41,$83,$68,$83,$8C,$83,$58,$81,$69,$24,$36,$30,$30,$30
   DB $81,$6A,$82,$CC,$4C,$53,$42,$82,$C9,$22,$30,$22,$82,$F0,$8F,$91
   DB $82,$AB,$8D,$9E,$82,$DE,$82,$B1,$0D,$0A,$81,$40,$81,$40,$81,$40
   DB $81,$40,$82,$C6,$82,$C5,$82,$E0,$89,$C2,$94,$5C,$82,$C5,$82,$B7
   DB $81,$42,$0D,$0A,$0D,$0A,$0D,$0A,$09,$35,$2E,$82,$BB,$82,$CC,$91
   DB $BC,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$83,$47,$83,$7E,$83
   DB $85,$83,$8C,$81,$5B,$83,$67,$82,$71,$82,$60,$82,$6C,$82,$CD,$83
   DB $47,$83,$7E,$83,$85,$83,$8C,$81,$5B,$83,$67,$8C,$E3,$82,$E0,$82
   DB $71,$82,$60,$82,$6C,$82,$C6,$82,$B5,$82,$C4,$8B,$40,$94,$5C,$82
   DB $B5,$82,$C4,$82,$A8,$82,$E8,$81,$41,$91,$53,$0D,$0A,$81,$40,$81
   DB $40,$81,$40,$81,$40,$97,$CC,$88,$E6,$82,$CC,$83,$66,$81,$5B,$83
   DB $5E,$8F,$91,$82,$AB,$91,$D6,$82,$A6,$82,$AA,$89,$C2,$94,$5C,$82
   DB $C5,$82,$A0,$82,$E9,$82,$BD,$82,$DF,$81,$41,$83,$66,$83,$6F,$83
   DB $62,$83,$4F,$8E,$9E,$82,$CD,$83,$82,$83,$6A,$83,$5E,$97,$CC,$88
   DB $E6,$82,$C6,$82,$B5,$0D,$0A,$81,$40,$81,$40,$81,$40,$81,$40,$82
   DB $C4,$93,$96,$91,$52,$8E,$67,$97,$70,$89,$C2,$94,$5C,$82,$C5,$82
   DB $A0,$82,$E9,$81,$42,$0D,$0A,$0D,$0A,$0D,$0A,$09,$83,$52,$83,$93
   DB $83,$67,$83,$8D,$81,$5B,$83,$8B,$83,$41,$83,$68,$83,$8C,$83,$58
   DB $09,$82,$55,$82,$4F,$82,$4F,$82,$4F,$82,$67,$0D,$0A,$09,$09,$62
   DB $69,$74,$30,$20,$2D,$2D,$3E,$20,$52,$41,$4D,$3C,$2D,$3E,$52,$4F
   DB $4D,$90,$D8,$82,$E8,$8A,$B7,$82,$A6,$09,$30,$3D,$83,$75,$81,$5B
   DB $83,$67,$52,$4F,$4D,$09,$31,$3D,$52,$41,$4D,$0D,$0A,$09,$09,$62
   DB $69,$74,$31,$20,$2D,$2D,$3E,$20,$42,$55,$5A,$5A,$45,$52,$09,$09
   DB $09,$30,$3D,$4F,$46,$46,$09,$09,$31,$3D,$4F,$4E,$0D,$0A,$09,$09
   DB $62,$69,$74,$32,$20,$2D,$2D,$3E,$20,$57,$52,$49,$54,$45,$20,$4C
   DB $45,$44,$09,$09,$30,$3D,$4F,$46,$46,$09,$09,$31,$3D,$4F,$4E,$0D
   DB $0A,$09,$09,$62,$69,$74,$33,$20,$2D,$2D,$3E,$20,$43,$50,$55,$20
   DB $52,$45,$53,$45,$54,$09,$09,$30,$3D,$4F,$46,$46,$09,$09,$31,$3D
   DB $4F,$4E,$0D,$0A,$09,$09,$62,$69,$74,$34,$7E,$37,$2D,$3E,$20,$96
   DB $A2,$8E,$67,$97,$70,$0D,$0A,$0D,$0A,$09,$92,$8D,$81,$6A,$43,$50
   DB $55,$20,$52,$45,$53,$45,$54,$90,$4D,$8D,$86,$82,$CD,$8A,$C8,$91
   DB $66,$89,$BB,$82,$CC,$82,$BD,$82,$DF,$92,$50,$82,$C8,$82,$E9,$94
   DB $F7,$95,$AA,$89,$F1,$98,$48,$82,$C5,$8D,$5C,$90,$AC,$82,$B5,$82
   DB $C4,$82,$A8,$82,$E8,$0D,$0A,$09,$81,$40,$81,$40,$52,$45,$53,$45
   DB $54,$8C,$E3,$82,$CD,$4C,$4F,$8F,$F3,$91,$D4,$82,$F0,$95,$DB,$8E
   DB $9D,$82,$B5,$82,$C4,$82,$A2,$82,$E9,$88,$D7,$81,$41,$8D,$C4,$52
   DB $45,$53,$45,$54,$82,$AA,$95,$4B,$97,$76,$82,$CC,$8F,$EA,$8D,$87
   DB $82,$CD,$88,$EA,$93,$78,$0D,$0A,$09,$81,$40,$81,$40,$48,$49,$82
   DB $F0,$8F,$91,$82,$AB,$8D,$9E,$82,$DD,$8E,$9F,$82,$C9,$4C,$4F,$82
   DB $F0,$8F,$91,$82,$AB,$8D,$9E,$82,$F1,$82,$C5,$44,$4F,$57,$4E,$83
   DB $47,$83,$62,$83,$57,$82,$F0,$94,$AD,$90,$B6,$82,$B3,$82,$B9,$82
   DB $E9,$82,$B1,$82,$C6,$81,$42,$0D,$0A,$0D,$0A,$0D,$0A,$0D,$0A,$09
   DB $34,$2E,$8C,$E3,$8F,$91,$82,$AB,$0D,$0A,$09,$96,$7B,$82,$71,$82
   DB $6E,$82,$6C,$83,$47,$83,$7E,$83,$85,$83,$8C,$81,$5B,$83,$5E,$82
   DB $CD,$83,$82,$83,$67,$83,$8D,$81,$5B,$83,$89,$90,$BB,$83,$8F,$83
   DB $93,$83,$60,$83,$62,$83,$76,$83,$7D,$83,$43,$83,$52,$83,$93,$82
   DB $C5,$82,$A0,$82,$E9,$82,$6C,$82,$62,$0D,$0A,$09,$82,$55,$82,$57
   DB $82,$67,$82,$62,$82,$50,$82,$50,$82,$F0,$8E,$67,$97,$70,$82,$B5
   DB $82,$BD,$8F,$AC,$8B,$4B,$96,$CD,$82,$C8,$83,$7B,$81,$5B,$83,$68
   DB $82,$CC,$83,$5C,$83,$74,$83,$67,$8A,$4A,$94,$AD,$82,$CC,$8C,$F8
   DB $97,$A6,$82,$F0,$8F,$AD,$82,$B5,$82,$C5,$0D,$0A,$09,$82,$E0,$83
   DB $41,$83,$62,$83,$76,$82,$B5,$82,$BD,$82,$A2,$82,$C6,$8E,$76,$82
   DB $A2,$90,$BB,$8D,$EC,$82,$B5,$82,$BD,$82,$E0,$82,$CC,$82,$C5,$82
   DB $B7,$81,$42,$0D,$0A,$0D,$0A,$09,$96,$7B,$8B,$40,$82,$CD,$81,$41
   DB $94,$C4,$97,$70,$82,$CC,$82,$71,$82,$6E,$82,$6C,$83,$47,$83,$7E
   DB $83,$85,$83,$8C,$81,$5B,$83,$5E,$82,$C6,$88,$D9,$82,$C8,$82,$E8
   DB $81,$41,$83,$5E,$81,$5B,$83,$51,$83,$62,$83,$67,$83,$7B,$81,$5B
   DB $83,$68,$8F,$E3,$82,$C9,$0D,$0A,$09,$82,$71,$82,$6E,$82,$6C,$83
   DB $41,$83,$68,$83,$8C,$83,$58,$82,$C6,$93,$AF,$88,$EA,$83,$41,$83
   DB $68,$83,$8C,$83,$58,$82,$C9,$82,$71,$82,$60,$82,$6C,$82,$F0,$94
   DB $7A,$92,$75,$82,$B5,$83,$5E,$81,$5B,$83,$51,$83,$62,$83,$67,$82
   DB $62,$82,$6F,$82,$74,$82,$CC,$0D,$0A,$09,$82,$72,$82,$62,$82,$68
   DB $8B,$40,$94,$5C,$82,$F0,$97,$98,$97,$70,$82,$B5,$82,$C4,$82,$71
   DB $82,$60,$82,$6C,$82,$C9,$83,$76,$83,$8D,$83,$4F,$83,$89,$83,$80
   DB $82,$F0,$83,$5F,$83,$45,$83,$93,$83,$8D,$81,$5B,$83,$68,$82,$B5
   DB $81,$41,$82,$BB,$82,$CC,$8C,$E3,$0D,$0A,$09,$82,$71,$82,$6E,$82
   DB $6C,$81,$7C,$81,$84,$82,$71,$82,$60,$82,$6C,$82,$C9,$83,$41,$83
   DB $4E,$83,$5A,$83,$58,$8C,$A0,$82,$F0,$97,$5E,$82,$A6,$82,$BD,$8C
   DB $E3,$81,$41,$82,$62,$82,$6F,$82,$74,$8E,$A9,$90,$67,$82,$C9,$83
   DB $8A,$83,$5A,$83,$62,$83,$67,$82,$F0,$0D,$0A,$09,$82,$A9,$82,$AF
   DB $81,$41,$8D,$C4,$8B,$4E,$93,$AE,$82,$B7,$82,$E9,$82,$E0,$82,$CC
   DB $82,$C5,$82,$B7,$81,$42,$0D,$0A,$0D,$0A,$09,$82,$BB,$82,$A4,$82
   DB $A2,$82,$A4,$88,$D3,$96,$A1,$82,$A9,$82,$E7,$82,$CD,$82,$71,$82
   DB $6E,$82,$6C,$83,$47,$83,$7E,$83,$85,$83,$8C,$81,$5B,$83,$5E,$82
   DB $C6,$82,$A2,$82,$A4,$82,$E6,$82,$E8,$82,$E0,$8A,$67,$92,$A3,$83
   DB $56,$83,$83,$83,$68,$83,$45,$82,$71,$0D,$0A,$09,$82,$60,$82,$6C
   DB $82,$C6,$8C,$BE,$82,$C1,$82,$BD,$82,$D9,$82,$A4,$82,$AA,$90,$B3
   DB $82,$B5,$82,$A2,$82,$CC,$82,$A9,$82,$E0,$92,$6D,$82,$EA,$82,$DC
   DB $82,$B9,$82,$F1,$81,$42,$0D,$0A,$0D,$0A,$0D,$0A,$09,$09,$09,$09
   DB $09,$09,$88,$C8,$81,$40,$81,$40,$8F,$E3,$0D,$0A,$1A
HELP_END:


;##################################################
DISABLE:
XIRQ:
IRQ:
   CLI
   RTI
;##################################################
; ͷƮ 
   ORG   $FFD6
;##################################################
VECTER:
   DW DISABLE    ;SCI SIRIAL SYSTEM
   DW DISABLE    ;SPI
   DW DISABLE    ;PULE ACCUM
   DW DISABLE    ;PULSE ACCUM. OVER
   DW DISABLE    ;TIMER OVERFLOW
   DW DISABLE    ;OCI_5
   DW DISABLE    ;OCI_4
   DW DISABLE    ;OCI_3
   DW DISABLE    ;OCI_2
   DW DISABLE    ;OCI_1
   DW DISABLE    ;ICI_3
   DW DISABLE    ;ICI_2
   DW DISABLE    ;ICI_1
   DW DISABLE    ;REAL TIME INTERRUPT
   DW IRQ      ;IRQ
   DW XIRQ     ;XIRQ
   DW DISABLE ;SWI
   DW P_TOP   ;ILLEGAL OPECODE
   DW DISABLE ;COP
   DW DISABLE ;COP MONITER
   DW P_TOP   ;RESET
;##################################################
   END
