	TITLE           "RS232C ͸ ǥϴ α׷ : PIC16C84"

;		Processor       16C84
;**********************************************************************
;		RS232C ͸ ǥϴ α׷ 
;	RS232c	: 9600, 4800, 2400, 1200,
;		    8Ʈ 1Ʈ, иƼ , ÷ 
;	16C84	: 10MHz.
;			1996 11/1 by S.Satoh
;**********************************************************************

 CBLOCK	0x0	;   巹 
	_ind0,_rtcc,_pcl,_status,_fsr
	_porta,_portb,_portc
	_eedata,_eeadr,_pclath,_intcon
 ENDC
_option	equ	0x1
_trisa	equ	0x5
_trisb	equ	0x6
_eecon1	equ	0x8
;	_status: ͽ ϴ Ʈ  
_c	equ	0
_dc	equ	1
_z	equ	2
_rp0	equ	5
;	ͷƮ  
#define		_rintf		_intcon,1
#define		_rtif		_intcon,2
#define		_rinte		_intcon,4
#define		_rtie		_intcon,5
#define		_gie		_intcon,7

;	_porta: AƮ ϴ Ʈ  
_baud0	equ	0
_baud1	equ	1
_baudMask	equ	0x3	; Ʈ ũ
;	_portb: BƮ ϴ Ʈ  
_RSin	equ	0	; ø  Է
_enb	equ	1	;  ̳̺ ȣ
_read	equ	2	;   о
_data	equ	3	;   Է
_db4	equ	4	;   
_db5	equ	5	;   
_db6	equ	6	;   
_db7	equ	7	;   
_BusyF	equ	0x80	; _db7 

 CBLOCK	0x0c	;   巹 
	_IntStatus	;  ͽ̴
	_SaveWReg	; ͷƮ W 
	_SaveStatus	; ͷƮ ͽ 
	_Save_fsr	; ͷƮ   
	_MainBuff,_cntBF1,_cntBF2	;  Ͻú
	_ver1,_ver2	; Ͻú
	_RSbit		; ø   Ʈ ȣ
	_RSbuf		; ø 
	_RSlen		; ø ȣ  
	_DisLen		;  ǥ  
	_Dtop		;   巹
 ENDC
MAXBUF	equ	0x10	;  
;
;	_IntStatus:  ͽ  Ʈ  
_NewLine	equ	2  ; 17 ̻   
_ctStart	equ	3	;  ΰ ǥ Ḧ Ÿ
_stFirst	equ	4	;  ǥϴ  Ÿ
_RSon	equ	5	; ø  
_RSend	equ	6	; ø Ʈ
_sFmask	equ	0x10	; _stFirst 

_RSbitTm	equ	0xbf	; RS232C  Ʈ 


;*********************************************************************
	ORG     0
	goto    Start
;
	
	ORG     4
	goto    Interrupt

;*********************************************************************
Start:
	call    Initial		;ʱȭ ƾ
	clrf	_RSlen
	clrf	_DisLen
	clrf	_IntStatus
	call	displayLOG
	bcf	_rintf
	bcf	_rtif
	bsf	_rinte
	bcf	_rtie
	bsf	_gie

Main_01:
	clrwdt
	bcf	_gie
	movf	_RSlen,0
	subwf	_DisLen,0
	btfss	_status,_c
	goto	Main_03

;  --------- ǥ Ͱ   ---------
	movlw	MAXBUF
	subwf	_DisLen,0
	btfss	_status,_c
	goto	Main_02

;  ------ ۰   ˻絵 Ѵ ------
	btfss	_IntStatus,_NewLine
	goto	Main_02

;  -------   ũ ִ , Ѵ -------
	clrf	_RSlen	 
	bcf	_IntStatus,_NewLine
	bsf	_gie
	clrf	_DisLen
	goto	Main_08

Main_02:
	bsf	_gie
	goto	Main_01


Main_03:   ;  --------- ǥ Ͱ ִ  ---------
	bsf	_gie
	btfsc	_IntStatus,_ctStart
	goto	Main_04

	movlw	0xf	; cursor on & blink
	call	LCwrite
	bsf	_IntStatus,_ctStart
Main_04:
	movlw	_Dtop
	addwf	_DisLen,0
	movwf	_fsr
	incf	_DisLen,1
	movf	_ind0,0
	andlw	0xf0
	btfsc	_status,_z  ;  ̸ܶ Main_06 
	goto	Main_06

;  ---------  ܶڰ ƴϸ 1 ǥ ---------
	movf	_ind0,0
	call	LDwrite
	goto	Main_01

Main_06:
;  --------- ܶ ó ---------
	movf	_DisLen,0  ;  1Į° ̸ܶ 
	xorlw	0x1
	btfsc	_status,_z
	goto	Main_01

;  ---------    Ѵ ---------
	clrf	_RSlen	 
	movlw	MAXBUF+2  ; ϴ ܶںе Ѵ
	movwf	_ver1
	movf	_DisLen,0
	subwf	_ver1,1
	clrf	_DisLen
Main_05:
	movlw	A' '
	call	LDwrite
	decfsz	_ver1,1
	goto	Main_05

Main_08:	; ---------   ̵Ѵ ---------
	movlw	_sFmask
	xorwf	_IntStatus,1
	movlw	0x80	; 1° 1Į°
	btfsc	_IntStatus,_stFirst
	movlw	0xc0	; 2° 1Į°
	call	LCwrite
	goto	Main_01



;############################# ƾ ##############################

; ================ ΰ ǥ ====================
displayLOG:
	movlw	0x2	; cursol to home
	call	LCwrite
	movlw	0xc	; erase cursor
	call	LCwrite
	movlw	0x6	; cursor direction is +1.
	call	LCwrite
	movlw	A'R'
	call	LDwrite
	movlw	A'S'
	call	LDwrite
	movlw	A' '
	call	LDwrite
	movlw	A'c'
	call	LDwrite
	movlw	A'h'
	call	LDwrite
	movlw	A'e'
	call	LDwrite
	movlw	A'c'
	call	LDwrite
	movlw	A'k'
	call	LDwrite
	movlw	A'e'
	call	LDwrite
	movlw	A'r'
	call	LDwrite
	movlw	A'-'
	call	LDwrite

; --------------- Ʈ ǥ --------------------
	movf	_porta,0
	xorlw	0xff
	andlw	_baudMask
	movwf	_ver1
	xorlw	0x0
	btfss	_status,_z
	goto	DisL_01

	movlw	A'9'
	call	LDwrite
	movlw	A'6'
	call	LDwrite
	goto	DisL_04

DisL_01:
	movf	_ver1,0
	xorlw	0x1
	btfss	_status,_z
	goto	DisL_02

	movlw	A'4'
	call	LDwrite
	movlw	A'8'
	call	LDwrite
	goto	DisL_04

DisL_02:
	movf	_ver1,0
	xorlw	0x2
	btfss	_status,_z
	goto	DisL_03

	movlw	A'2'
	call	LDwrite
	movlw	A'4'
	call	LDwrite
	goto	DisL_04

DisL_03:
	movlw	A'1'
	call	LDwrite
	movlw	A'2'
	call	LDwrite

DisL_04:
	movlw	A'0'
	call	LDwrite
	movlw	A'0'
	call	LDwrite

	movlw	0xc0	; 2° 1Į°
	call	LCwrite
	movlw	A'b'
	call	LDwrite
	movlw	A'y'
	call	LDwrite
	movlw	A' '
	call	LDwrite
	movlw	A'S'
	call	LDwrite
	movlw	A'.'
	call	LDwrite
	movlw	A'S'
	call	LDwrite
	movlw	A'a'
	call	LDwrite
	movlw	A't'
	call	LDwrite
	movlw	A'o'
	call	LDwrite
	movlw	A'h'
	call	LDwrite
	movlw	0x80	; 1° 1Į°
	call	LCwrite
	return


; =========  (w) ǥýŲ  ==========
LDwrite:
	clrf	_portb
	bsf	_portb,_data
	goto	LCw_01

; =======  νƮ(w) Ų ======
LCwrite:
	clrf	_portb
LCw_01:
	movwf	_MainBuff
	bsf	_status,_rp0
	movlw	1
	movwf	_trisb		;  4Ʈ   
	bcf	_status,_rp0
	movlw	0xc
	andwf	_portb,1		;   
	movf	_MainBuff,0
	andlw	0xf0
	iorwf	_portb,1		;    4Ʈ 
	bsf	_portb,_enb
	movlw	0xc		;   ũ
	bcf	_portb,_enb
	andwf	_portb,1		;   
	swapf	_MainBuff,0
	andlw	0xf0
	iorwf	_portb,1		;    4Ʈ 
	bsf	_portb,_enb
	nop			; Ʈ
	bcf	_portb,_enb
	call	waitBF		;  ε 
	return


;==========  ε Ḧ ٸ =============
waitBF:
	clrf	_cntBF1
	clrf	_cntBF2
wBF_01:
	bsf	_status,_rp0
	movlw	0xf1		;  4Ʈ  Է¼
	movwf	_trisb
	bcf	_status,_rp0
	clrf	_portb
	bsf	_portb,_read
	bsf	_portb,_enb
	nop
	movf	_portb,0
	bcf	_portb,_enb
	nop
	bsf	_portb,_enb
	nop
	bcf	_portb,_enb
	andlw	_BusyF		; ε ?
	btfsc	_status,_z
	return

	decfsz	_cntBF1,1
	goto	wBF_01

	decfsz	_cntBF2,1
	goto	wBF_01

	return



;********************* ʱ⼳ ***********************
Initial:
	clrf	_intcon
	clrf	_IntStatus
	bsf	_status,_rp0
	movlw	0x1f		; Ʈ A  
	movwf	_trisa
	movlw	0xff
	movwf	_porta
	movlw	1		; Ʈ B  
	movwf	_trisb
	movlw	0xc8		; ɼ 
	movwf	_option	; _RSin ¿ ͷƮ 
	bcf	_status,_rp0
	movlw	0x20		;  4Ʈ ۽Ų
	movwf	_portb
	bsf	_portb,_enb
	nop
	bcf	_portb,_enb
	call	waitBF
	movlw	0x28		;  2 ǥýŲ
	call	LCwrite
	movlw	0x1		; Ŀ Ȩ
	call	LCwrite
	movlw	0xc	; Ŀ ǥ ʴ´
	call	LCwrite
	movlw	0x6	; Ŀ  ̵ 
	call	LCwrite

	return



;**************** ͷƮ ó ƾ ****************
Interrupt:
	btfsc	_rtif
	goto	Int_00		; ̸ ͷƮΰ?

	btfsc	_rintf		; _RSin ͷƮΰ?
	goto	Int_00

	retfie

Int_00:
	movwf	_SaveWReg	;    
	swapf	_status,0
	movwf	_SaveStatus
	swapf	_fsr,0
	movwf	_Save_fsr

	btfsc	_rtif		; Ÿ̸ ͷƮ ó
	call	SetRS_Sub

	btfsc	_rintf		; _RSin ͷƮ ó
	call	SetStartBit

	swapf	_Save_fsr,0	;    
	movwf	_fsr
	swapf	_SaveStatus,0
	movwf	_status
	swapf	_SaveWReg,1
	swapf	_SaveWReg,0
	bcf	_rintf
	bcf	_rtif
	retfie



; ============= Ÿ̸ ͷƮ ó ============
SetRS_Sub:
	btfss	_IntStatus,_RSon
	return	; RS232C   ƴϸ ư

	btfss	_IntStatus,_RSend
	goto	SRS_01

;  ---------  Ʈ   ---------
	movlw	0xc8
	bsf	_status,_rp0
	movwf	_option		; _RSin ͷƮ 
	bcf	_status,_rp0
	bcf	_IntStatus,_RSend
	bcf	_IntStatus,_RSon
	bsf	_rinte
	bcf	_rtie
	return

SRS_01:
;  ---------   Ʈ ð  ---------
	movlw	_RSbitTm
	movwf	_rtcc
	movf	_porta,0	; Ʈ  ̼ 
	andlw	_baudMask
	addwf	_rtcc,1
	xorlw	_baudMask
	btfss	_status,_z
	goto	SRS_02

	movlw	4
	addwf	_rtcc,1
SRS_02:
;  ---------  1Ʈ   ---------
	bcf	_status,_c
	btfss	_portb,_RSin	; RS232C  ˻
	bsf	_status,_c
	rrf	_RSbuf,1
	bcf	_rinte
	bsf	_rtie
	incf	_RSbit,1
	movlw	8
	subwf	_RSbit,0
	btfss	_status,_c
	return

;  --------- 8Ʈ ߴٸ 1Ʈ ͷμ ó ---------
	movlw	_Dtop		;   
	addwf	_RSlen,0	;  ֱ 
	movwf	_fsr
	bsf	_IntStatus,_RSend

	movlw	MAXBUF
	subwf	_RSlen,0
	btfss	_status,_c
	goto	SRS_03

;  --------- ۰   ó Ѵ ---------
	movf	_RSbuf,0
	andlw	0xf0
	btfsc	_status,_z	; ̸ܶ _NewLine 
	bsf	_IntStatus,_NewLine
	return

SRS_03:
; --------- ۰  ִٸ  ---------
	movf	_RSbuf,0
	movwf	_ind0
	incf	_RSlen,1
	return


; ====== _RSin ͷƮ(ŸƮ Ʈ )ó =======
SetStartBit:
	btfsc	_IntStatus,_RSon
	return

	movf	_porta,0	; Ʈ  о̱
	xorlw	0xff
	andlw	_baudMask
	addlw	0xc1		; Ÿ̸/īƮ 
	bsf	_status,_rp0
	movwf	_option		; Ÿ̸ ͷƮ 
	bcf	_status,_rp0
	movlw	_RSbitTm
	movwf	_rtcc
	clrf	_RSbit
	clrf	_RSbuf
	bsf	_IntStatus,_RSon
	bcf	_rinte
	bsf	_rtie
	return

END
