TITLE        "ø󿡼 GPIB ȯϴ α׷ : PIC16C55 or PIC16C57"

;              Processor       16C55 or 16C57
;****************************************************************************
; ø(RS232C) GPIB ȯϴ α׷
; RS232c : 9600, 8Ʈ 1Ʈ, иƼ , ÷ 
; PIC16C55 or 16C57 : 20MHz.
; 2000 5/12, 12/11 by S.Satoh
;****************************************************************************

 CBLOCK 0x0      ;   巹 
   _indf,_tmr0,_pcl,_status,_fsr
   _porta,_portb,_portc
 ENDC
;_status: ͽ ϴ Ʈ 
_c    equ   0
_dc   equ   1
_z    equ   2
_rp0 equ   5
;_porta: AƮ ϴ Ʈ 
_RSin    equ  2  ; ø  Է
_oSend   equ  3  ; GPIB ׼ LED ´
;_portb: BƮ ϴ Ʈ 
_ren equ   0  ; GPIB REN
_eoi equ   1  ; GPIB EOI
_dav equ   2  ; GPIB DAV
_nrfd equ  3  ; GPIB NRFD
_ndac equ  4  ; GPIB NDAC
_ifc equ   5  ; GPIB IFC
_srq equ   6  ; GPIB SRQ
_atn equ   7  ; GPIB ATN

 CBLOCK 0x08  ;   巹 
   _RGstatus  ;  ͽ
   _RSbit      ; ø   Ʈ ȣ
   _RSbuf      ; ø 
   _RSlen      ; ø  ͼ
   _GPnow      ; GPIB óȣ
   _GPlen      ; GPIB ó ͼ
   _Dtop       ;   巹
 ENDC
MAXBUF   equ  (0x20-_Dtop)  ; ۼ
;
; _RGstatus: RG ͽ ϴ Ʈ 
_RSinb   equ  0  ; ø Է» 
_RSon    equ  1  ; ø  
_RSend   equ  2  ; ø Ʈ 
_RScom   equ  3  ; ø Ŀǵ 
_RSesc   equ  4  ; ø   
_GPson   equ  5  ; GPIB  ۽
_GPend   equ  6  ; GPIB EOI ο
;

   ORG     0
   goto    Start
;
SetWaitSub:   ; Ÿ̸ӿ ðǥ
   andlw 0x7
   addwf _pcl,1
   retlw 0x12 ;  104 micro second
   retlw 0x22 ;  208 micro second
   retlw 0x32 ;  313 micro second
   retlw 0x43 ;  417 micro second
   retlw 0x53 ;  521 micro second
   retlw 0x63 ;  625 micro second
   retlw 0x73 ;  730 micro second
   retlw 0x84 ;  834 micro second

;*********************************************************************

Start:
   movlw 0xff
   movwf _porta
   movwf _portb
   movlw 0x7
   tris _porta
   movlw 0x5e    ; GPIB Ʈѷ
   tris _portb   ; ATN,IFC,REN  
   movlw 0xff    ; GPIB   Է 
   tris _portc
   movlw 0x4     ; TMR0  Ŭ 1/32(6.4 uS)
   option         ; 9600 16.276 īƮ/
   clrf _RSbit
   clrf _RSbuf
   clrf _RSlen
   clrf _GPlen
   clrf _GPnow
   clrf _RGstatus
Main_00:
   clrwdt
   btfsc _RGstatus,_RSon ; ø Էΰ?
   goto Main_02

   btfss _RGstatus,_RSinb ; ŸƮ Ʈΰ?
   goto Main_01


; --------- ø  Ʈ Է° ʱ⼳ --------- 
   clrf _RSbit            ; initialize for getting RS
   clrf _RSbuf
   bcf   _RGstatus,_RSinb ; clear RS start bit
   bsf   _RGstatus,_RSon
   clrf _tmr0
   goto Main_10           ; to GPIB loop

Main_01:
; btfsc _porta,_RSin    ī÷  
   btfss _porta,_RSin
   goto Main_10           ; to GPIB loop

   bsf   _RGstatus,_RSinb ; get RS start bit
   goto Main_10           ; to GPIB loop


Main_02: ; --------- ø  Ʈ Է  ---------
   movf _RSbit,0
   call SetWaitSub
   subwf _tmr0,0
   btfss _status,_c    ;   ðΰ?
   goto Main_10        ; to GPIB loop
   
   btfss _RGstatus,_RSend
   goto Main_05


;  --------- Ʈ  ---------
   bcf   _RGstatus,_RSend
   bcf   _RGstatus,_RSon
   bsf   _portb,_ifc ; ׻ GPIB IFC Ŭ
; ̰ 'I' Ŀǵ  1Ʈ ݸŭ
; IFC ο ϸ  Ƿ
   goto Main_00


Main_05: ; --------- ø Ʈ   ---------
   bcf   _status,_c
; btfsc _porta,_RSin    Ŀ÷  
   btfss _porta,_RSin
   bsf   _status,_c
   rrf   _RSbuf,1
   incf _RSbit,1
   movlw 8
   subwf _RSbit,0
   btfss _status,_c
   goto Main_00


; --------- 8Ʈ(1Ʈ)  Ϸ ó ---------
   clrf _tmr0             ; (_RSbit) >= 8
   clrf _RSbit
   bsf   _RGstatus,_RSend ;  Ʈ 
   btfsc _RGstatus,_RScom ; Ŀǵ ؼ ?
   goto Main_04

   call SetCommand     ; Ŀǵ带 ؼѴ
   goto Main_00

Main_04:
   movf _RSbuf,0
   xorlw 0xd
   btfss _status,_z    ; ĳ ΰ?
   goto Main_06

   bcf   _RGstatus,_RScom  ; Ŀǵ ؼ Ŭ
   goto Main_08

;  ---------   ó ---------
Main_06:
   btfsc _RGstatus,_RSesc  ;  ΰ?
   call ChangeESC

   movf _RSbuf,0
   xorlw 0x5c
   btfss _status,_z    ; ()ΰ?
   goto Main_08

   bsf   _RGstatus,_RSesc
   goto Main_00

Main_08:
   bcf   _RGstatus,_RSesc


;  --------- 1Ʈ   ---------
   movlw _Dtop      ;   巹
   addwf _RSlen,0
   movwf _fsr       ;  巹 
   movf _RSbuf,0
   movwf _indf      ; 1Ʈ  ֱ
   clrf _RSbuf
   incf _RSlen,1    ; ۸ ϳ Ų

   movlw MAXBUF
   subwf _RSlen,0
   btfsc _status,_c ; _RSlen>=MAXBUF̸
   decf _RSlen,1    ; ÷̹Ƿ
;  ޸𸮿 ľ

   goto Main_00


;################## GPIB ó ########################
Main_10:
   btfss _RGstatus,_GPson ; GPIB  ΰ?
   goto Main_00

   movf _GPnow,0
   btfss _status,_z       ;   ó κΰ?
   goto Main_30

;  ---------   ó κ ---------
   btfsc _portb,_ndac ; NDAC ο ΰ?
   goto Main_00

   btfss _portb,_nrfd ; NRFD  ΰ?
   goto Main_00

   incf _GPlen,1
   movf _GPlen,0
   subwf _RSlen,0      ;  ޸𸮴 °?
   btfss _status,_c
   goto Main_22

   movlw _Dtop-1
   addwf _GPlen,0
   movwf _fsr
   movf _indf,0
   xorlw 0xd
   btfss _status,_z    ; ĳ 
   goto Main_23        ;(  )ΰ?

   bsf   _RGstatus,_GPend
   btfss _portb,_atn  ; Ŀǵ 
   goto Main_21        ;(ATN ο)̸ ٷ Ѵ

Main_23:
   movf _indf,0
   xorlw 0xff
   movwf _portc        ;  Ʈ
   incf _GPnow,1
   btfsc _RGstatus,_GPend ;   ̸
   bcf   _portb,_eoi      ; EOI ο Ѵ

   movlw 0                 ;   »· Ѵ
   tris _portc
   movlw 0x58             ; ATN,IFC,DAV,EOI,REN  Ѵ
   tris _portb
   bcf   _portb,_dav      ; DAV ο · Ѵ
   goto Main_00

Main_21:
;  ---------  Ŭ ó ---------
   bcf   _RGstatus,_GPson
   bcf   _RGstatus,_GPend
   bsf   _portb,_atn
   bsf   _porta,_oSend ; send LED off
Main_22:
   clrf _RSlen      ;  ޸𸮸 0 Ѵ
   clrf _GPlen
   goto Main_00


Main_30:
   movf _GPnow,0
   xorlw 1           ;   Ĺó κΰ?
   btfss _status,_z
   goto Main_00

;  ---------   Ĺó κ ---------
   btfss _portb,_ndac     ; NDAC  ΰ?
   goto Main_00

   clrf _GPnow
   bsf   _portb,_dav
   bsf   _portb,_eoi
   movlw 0xff             ;   Է»· Ѵ
   tris _portc
   movlw 0x5e             ; ATN,IFC,REN  Ѵ
   tris _portb
   btfsc _RGstatus,_GPend ; EOI ο̸
   goto Main_21           ; Ŭ ó Ѵ

   goto Main_00


;#################### ƾ ####################

;--------------- Ŀǵ ؼ --------------------
SetCommand:
   movf _porta,0    ; AƮ ID о̱
   andlw 0x3
   subwf _RSbuf,0   ; (_ver) - (porta sw)
   andlw 0xdf       ; ̰ Ŀǵ尡 ԰ȭǾ
   movwf _RSbuf
   clrf _GPnow
   clrf _GPlen

   movf _RSbuf,0
   xorlw A'A'          ; Ŀǵ 'A'ΰ?
   btfss _status,_z
   goto SetC_11

   bcf   _portb,_ren
   bcf   _portb,_atn  ; ATN ο · Ѵ
   goto SetC_12

SetC_11:
   movf _RSbuf,0
   xorlw A'S'          ; Ŀǵ 'S'ΰ?
   btfss _status,_z
   goto SetC_13

   bcf   _portb,_ren
   bsf   _portb,_atn
SetC_12:
   bsf   _RGstatus,_GPson
   bcf   _porta,_oSend ; send LED on
   bsf   _RGstatus,_RScom
   goto SetC_14

SetC_13:
   movf _RSbuf,0
   xorlw A'I'          ; Ŀǵ 'I'ΰ?
   btfss _status,_z
   retlw 1

   bcf   _RGstatus,_GPson
   bsf   _porta,_oSend ; send LED off
   movlw 0xff
   movwf _portb
   tris _portc
   bcf   _portb,_ifc
   clrf _tmr0          ; Ʈ ̿Ѵ
;  100ũ ̻̹Ƿ Ѵ
SetC_14:
   clrf _RSlen
   clrf _GPlen
   retlw 0


;---------------   ؼ --------------------
ChangeESC:
   movf _RSbuf,0
   xorlw A'r'          ; ĳ ?
   btfss _status,_z
   goto EscSub_01

   movlw 0xd
   movwf _RSbuf
   retlw 0

EscSub_01:
   movf _RSbuf,0
   xorlw A'n'          ; ǵ ?
   btfss _status,_z
   goto EscSub_02

   movlw 0xa
   movwf _RSbuf
   retlw 0

EscSub_02:
   movlw A'0'          ; '0' ̻ ?
   subwf _RSbuf,0
   btfss _status,_c
   retlw 0

   movlw A'9'+1        ; '9' ̸ ?
   subwf _RSbuf,0
   btfss _status,_c
   goto EscSub_03

   movlw A'A'          ; 'A' ̻ ?
   subwf _RSbuf,0
   btfss _status,_c
   retlw 0

   movlw A'F'+1        ; 'F' ̸ ?
   subwf _RSbuf,0
   btfsc _status,_c
   retlw 0

EscSub_03:
   movf _RSbuf,0
   andlw 0xf
   movwf _RSbuf
   retlw 0


   END

