/*
** з Ʈ  ǿ  ƾ
**
**  PC/AT(IBM-PC) pararel PORT 0x378
**
** з Ʈ 
**    pinit()     з Ʈ ʱȭ
**    pend()      з Ʈ 
**    pmode(mode) з Ʈ  
** Ʈ Ʈ 
**    bit_set(port,bit,dat)
**    bit_get(port,bit)
*/
/*
** α׷Ӻ ͹ Ÿ̸  Ķ ۼ ƾ
** 98ý Ŭ ڵǺ ͣͣ, IBM-PC
**
** ø Ʈ ( ) Ѵ
**    #define s_rate xx
**  Ÿ̸ īƮ 
**    TMset()
** Ǵ 
** int ts,tk;
**    ts = ø Ʈ   Уɣ īƮ
**    tk = ø Ʈ Ȯ ð(n )
*/

/*
** Ŀ Ÿ Ʈ
**/
void wait(void)
{
#ifdef PC_98
   outportb(0x5c,0); /*PC98 1uS*/
#endif
#ifdef PC_AT
   inportb(0x61); /*PCAT 1uS*/
#endif
}

/*--- з Ʈ --------------------------------------------------------*/
/*
**    з Ʈ  ɣ 巹 
*/
#ifdef PC_98
    #define DP 0x140      /* DATA */
    #define SP 0x141      /* STAT */
    #define CP 0x142      /* CTRL */
#endif
#define IP 0x149          /* SELECT(98) */
#ifdef PC_AT
    #define DP 0x378      /* DATA */
    #define SP 0x379      /* STAT */
    #define CP 0x37a      /* CTRL */
#endif
/* ͽ Ʈ Ʈ */
#define PDIR  0x20
#define ACK   0x40
#define BUSY  0x80
/*Ʈ Ʈ Ʈ */
#define STROBE 0x01
#define AUTOFD 0x02
#define INIT   0x04
#define SLCTIN 0x08

/*pmode  */
#define PINPUT  0
#define POUTPUT 1
#define PON     2
#define POFF    3

/*
** з Ʈ ʱȭ
** pinit()
**    out : =0
*/
int pinit(void)
{
#ifdef PC_98
   outportb(IP,0x10); /*Ǯ Ʈδн (PC98)*/
   if(!(peekb(0,0x458)&0x02) || inportb(IP)!=0x10) {
      return(1);
   }
#endif
   outportb(CP,0x04); /*ͷƮ */
   return(0);
}
/*
** з Ʈ 
** pend()
**    out : =0
*/
void pend(void)
{
   outportb(CP,0x04); /*ͷƮ */
#ifdef PC_98
   outportb(IP,0x00); /*Ʈδн ذ (PC98)*/
#endif
}
/*
** з Ʈ  
** pmode(mode)
**    mode : 
**      PINPUT  з Ʈ Է  Ѵ
**      POUTPUT з Ʈ   Ѵ
**      PON     ܺȸθ Ƽ() Ѵ
**      POFF    ܺȸθ ξƼ(OFF Ǵ Է) Ѵ
**    out  : 
*/
void pmode(int mode)
{
int dat;
   dat=inportb(CP);
   if(mode==PINPUT) dat=dat | PDIR;
   if(mode==POUTPUT) dat=dat & ~PDIR;
   if(mode==POFF) dat=dat | INIT;
   if(mode==PON) dat=dat & ~INIT;
   outportb(CP,dat);
}
/*
** Ʈ Ʈ 
** bit_set(port,bit,dat)
**    port : Ʈ 巹
**   bit  :  Ʈ(0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80)
**   dat  :  (0,1)
**    out  : 
** bit_get(port,bit)
**    port : Ʈ 巹
**   bit  :  Ʈ(0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80)
**    out  : Ʈ (0,1)
*/
void bit_set(int port,int bit,int dat)
{
int wk;
   wk=inportb(port);
   if(dat) wk=wk | bit; else wk=wk & ~bit; 
   outportb(port,wk);
}
int bit_get(int port,int bit)
{
   if(inportb(port) & bit) return(1); else return(0);
}

/*--- α׷Ӻ ͹ ̸ ------------------------------------*/
#ifdef s_rate
/*
** Уɣԡ巹 
*/
#ifdef PC_98
#define PITD    0x75  /*ī Ʈ*/
#define PITC    0x77  /* */
#define PITinit 0x94  /* ʱȭ 2ch,,mode=2*/
#endif
#ifdef PC_AT
#define PITD    0x42  /*ī Ʈ */
#define PITC    0x43  /* */
#define PITinit 0x94  /* ʱȭ 2ch,,mode=2*/
#endif
/*
** УɣԿ Ŭ ļ 
**/
#define PITfreq25 2457600 /*PC98 system clock = 5/10MHz*/
#define PITfreq20 1996800 /*PC98 system clock = 8MHz*/
#define PITfreq12 1193180 /*PCAT*/

int ts,tk;

/*
**  Ÿ̸ īƮ 
** TMset()
**    out :
**    ts  = s_rate(uS) īƮ
**    tk  = ø (nS)
**/
void TMset(void)
{
double dd;
#ifdef PC_98
   /*ý ŬϿ  Ÿ̸ Ŭ */
   if(peekb(0,0x501)&0x80) dd=PITfreq20; else dd=PITfreq25;
#endif
#ifdef PC_AT
  dd=PITfreq12;
   /*Уɣԡ  ϣ*/
   bit_set(0x61,0x01,1);
#endif
   ts=floor((dd*(double)s_rate/(1000000))+0.5);
   tk=floor(((double)ts*1000000000/dd)+0.5);
}
#endif
