/*
**  Ʈũ ֳζ
**
**    for BC++4.0J
** PC98 : bcc /DPC_98 -ms net.c graphics.lib
** PCAT : bcc /DPC_AT -ms net.c graphics.lib
*/
#include<graphics.h>
#include<alloc.h>
#include<math.h>
#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<string.h>
#include<dos.h>
#include<io.h>
#include<fcntl.h>
#include<sys\stat.h>
#include"parallel.h"

/*
** ģģ, ģ   
*/
/* ģģ Ŭ (Hz) */
#define DDS_CLK 67108860
/* ģģ  Ʈ  */
#define DST  0x01
#define DCK  0x02
#define DDT  0x04
/* ģ  Ʈ  */
#define CS   0x08
#define SCLK 0x10
#define DIN  0x20
#define DOUT ACK
#define EOC  BUSY
/* ģÿ Ŀǵ  50Hz=0x40/60Hz=0x00 */
#define ADC_CMD 0x40
/* ģ Ǯ (18bit) */
#define FULSCAL 262144

/*
**  ׷   
*/
/* ׷  Ʈ */
#define sclstp 30 
/* ؽƮ ǥ  */
#ifdef PC_98
  #define ty0    18
  #define ty1    20
  #define ty2    22
  #define ty9    16
#endif
#ifdef PC_AT
  #define ty0    16
  #define ty1    18
  #define ty2    20
  #define ty9    14
#endif
/*
** ̵溸,  ſ 
*/
double max_lim[640],min_lim;

/*
** Ű 
*/
#define KEY_UP    '8'
#define KEY_DOWN  '2'
#define KEY_RIGHT '6'
#define KEY_LEFT  '4'

/*
** ̽ ǥ
*/
void clrline(int ln)
{
   for(;ln>0;ln--) printf(" ");
}
/*======================
    ģģ 
=======================*/
/*
** ģģӿ Ŀǵ带 
** dds_send(ch,cmd,dat)
** in :
**    ch  = ģģӣ̣ӣ ȣ
**    cmd = ģģ Ŀǵ ȣ
**    dat = ļ 
*/
void dds_send(int ch,int cmd,long dat)
{
int i;
   for(i=0;i<3;i++) {bit_set(DP,DDT,ch&1); ch=ch >> 1; bit_set(DP,DCK,0); bit_set(DP,DCK,1);}
   for(i=0;i<4;i++) {bit_set(DP,DDT,cmd&1); cmd=cmd >> 1; bit_set(DP,DCK,0); bit_set(DP,DCK,1);}
   for(i=0;i<26;i++) {bit_set(DP,DDT,dat&1); dat=dat >> 1; bit_set(DP,DCK,0); bit_set(DP,DCK,1);}
   bit_set(DP,DST,0); bit_set(DP,DST,1);
}
/*
**  ļ ߻Ų
** dds(freq)
** in :
**    freq = ļ 
*/
void dds(long freq)
{
double dat1;
long   dat2;
   dat1=(DDS_CLK*(double)freq)/67108864;
   dat2=dat1+0.5;
   dds_send(7,12,dat2);
}
/*======================
    ģ 
=======================*/
/*
** ģ Ϳ Ŀǵ带 ְ, ģ÷κ ͸ Ѵ
** adc_sr(wr)
** in :
**    wr = Ŀǵ
** out : (8bit)
*/
int adc_sr(int wr)
{
int i,rd;
   bit_set(DP,CS,0);/*CS=0*/
   for(i=rd=0;i<8;i++) {
      if(wr&0x80) bit_set(DP,DIN,1); else bit_set(DP,DIN,0);
      wr=wr << 1; /*ֱ*/
      rd=rd << 1; rd=rd | bit_get(SP,DOUT); /*о̱*/
      bit_set(DP,SCLK,1); bit_set(DP,SCLK,0); /*Ʈ*/
   }
   bit_set(DP,CS,1);/*CS=1*/
   return(rd);
}
/*
** ģÿ Ŀǵ带 , ļ ͸ Ѵ
** adc(cmd)
** in :
**    cmd = Ŀǵ(ADC_CMD)
** out : ļ 
*/
long adc(int cmd)
{
unsigned int long dat;
int sgn;
   for(;;) if(adc_sr(cmd | 0x02) & 0x40) break;/*EOC=1  Reg2*/
   adc_sr(cmd | 0x82);/*ȯ Reg2*/
   for(;;) if(adc_sr(cmd | 0x02) & 0x40) break;/*EOC=1  Reg2*/
   dat=adc_sr(cmd);/*/02-00 Reg0*/
   dat=dat & 0x07;
   dat=dat | (adc_sr(cmd | 0x04) << 3);/*10-03 Reg1*/
   dat=dat | ((unsigned long)(sgn=adc_sr(cmd | 0x02)) << 11);/*18-11 Reg2*/
   if(sgn&0x80) dat=dat | 0xfffc0000;/*ȣ Ȯ*/
   return(dat);
}
/*
** ģø ʱȭѴ
** adc_init()
*/
void adc_init(void)
{
   bit_set(DP,CS,0);/*CS=0*/
   bit_set(DP,SCLK,0);/*Sclk=0*/
   adc_sr(ADC_CMD | 0x12);/* ʱȭ 50Hz Awake ReadZero Reg2*/
   adc(ADC_CMD | 0x90);/*ReadZero*/
   adc(ADC_CMD | 0x90);/*ReadZero*/
   adc(ADC_CMD | 0x90);/*ReadZero*/
}

/*======================
    ƾ
=======================*/
/*
** ȭ ΰ ģ б, -60db ̳ ϸ ߴ
** adcave(ave,reng)
** in :
**    ave  = ǥ
**    reng = 
** out  : бⰪ 
*/
long adcave(int ave,long reng)
{
int j;
long ad;
double dd1,dd2;
   for(dd1=0,j=0;j<ave;j++) {
      if((ad=adc(ADC_CMD)-min_lim)<=0) ad=1;
      /*ȭ Ȯ*/
      if(j>=2) {
         dd2=(fabs((dd1/(double)j)-(double)ad)/reng);
         if(dd2<0.001) break; /* 0.001=60db*/
      }
      dd1+=(double)ad;
   }
   ad=floor(dd1/(double)j);
   return(ad);
}
/*======================
    Ŀǵ ó
=======================*/
/*
** ׷  ǥ( ǥ)
** screen()
*/
void screen(void)
{
int i;
double dd;
   /*ȭҰ*/
   setfillstyle(CLOSE_DOT_FILL,BLACK);
   bar(20,20,619,20+sclstp*7);
   setcolor(BLUE);
   setlinestyle(USERBIT_LINE,0x5555,NORM_WIDTH);
   /*ǥ(̵棩*/
   for(i=20;i<=20+sclstp*7;i=i+sclstp) {
      if(i!=20+sclstp) setcolor(BLUE); else setcolor(RED);
      line(20,i,619,i);
   }
   /*Ⱦǥ(ļ*/
   for(dd=1;dd<=10;dd++) {
      i=floor(100*log10(dd));
      for(i=i+20;i<=620;i=i+100) line(i,20,i,20+sclstp*7);
   }
   setlinestyle(SOLID_LINE,0,NORM_WIDTH);
   rectangle(20,20,620,20+sclstp*7);
}
/*
** ׷ ȭ
** graph(mode,ave)
** in :
**    mode = 0=max_lim ʱȭ 1= 2=FƯ ǥ
**    ave  = ȭ ǥ
*/
void graph(int mode,int ave)
{
int i,j,ry;
long ad,reng;
double dd,dd1,dd2;

   if(mode==0) {/*Ư ʱȭ*/
      max_lim[0]=min_lim;
      for(i=1;i<640;i++) max_lim[i]=FULSCAL;
   }
   if(mode==2) {/*׷ ȭ*/
      for(i=70,reng=0;i<=600;i++) if(max_lim[i]>reng) reng=max_lim[i];
   } else {
      /*ģģ */
      dds_send(7,1,0);
      dds(50); adc(ADC_CMD);/*ý */
   }
   setcolor(GREEN);
   for(i=70;i<=600;i++) { /*70=50Hz 630=20MHz*/
      if(kbhit()) break;/*ߴ*/
      /*ļ */
      dd=pow(10,(double)(i+100)/100);
      dds(dd);
      /* б*/
      if(mode==2) ad=max_lim[i]; else {reng=max_lim[i]; ad=adcave(ave,reng);}
      if(mode==0) max_lim[i]=ad;
      dd2=20*log10((double)ad/(double)reng);
      gotoxy(1,ty2); printf("%5.2fKHz %3.1fdb ",dd/1000,dd2);
      /*  ÷*/
      if(dd2>10) dd2=10;   /*max limit over*/
      if(dd2<-60) dd2=-60; /*min limit ovre*/
      dd2=sclstp+20-dd2*3;
      if(i>70) line(i+19,ry,i+20,dd2);
      ry=dd2;
   }
   gotoxy(1,ty2); clrline(20);
   /*ģģ */
   dds_send(7,0,0);/*DDS-OFF*/
}
/*
** ȣ ( ĵ)
** zerov(mode)
** in :
**    mode = 0=FreeRun 1=ϱ ٸ
*/
void zerov(int mode)
{
int i,j;
long ad,old;
double dd;
   /*ģģ */
   dds_send(7,0,0);/*DDS-OFF*/
   gotoxy(1,ty2); printf("  հ=      =");
   for(i=0;!kbhit();i++) {
      ad=adc(ADC_CMD);
      /*ƣӰ  (ppm)*/
      dd=fabs((min_lim-(double)ad)/FULSCAL)*1000000;
      gotoxy(43,ty2); printf("%ldppm  ",(long)dd);
      /* */
      if(mode && i>10) {
         if(dd<100) j++; else j=0;
         if(j>3) break; /*100ppm(-80db) 3ȸ ߴٸ   Ѵ*/
      }
      /*ֽ ȸ հ*/
      dd=min_lim*10+(double)ad; min_lim=dd/11;
      gotoxy(23,ty2); printf("%6.1fV",min_lim*2);
   }
   gotoxy(1,ty2); clrline(60);
}
/*
**  ļ ߻
** tone()
*/
void tone(void)
{
long fq,step;
char key;
   dds_send(7,1,0);/*DDS-ON*/
   gotoxy(1,ty2); printf("freq=1.000KHz step=1.000KHz");
   for(fq=1000,key=0,step=1000;key!=27;) {
      dds(fq);
      for(;!kbhit();) {gotoxy(36,ty2); printf("LEVEL = %ld     ",adc(ADC_CMD));}
      key=getch();
      if(key==KEY_LEFT && fq-step>=0) fq-=step;/*ļ*/
      if(key==KEY_RIGHT) fq+=step;             /*ļ*/
      if(key==KEY_UP && step<1000000) step*=10;/*ܣ*/
      if(key==KEY_DOWN && step>10) step/=10;   /*ܣ*/
      gotoxy(1,ty2);
      printf("freq=%1.3fKHz step=%1.3fKHz     ",(double)fq/1000,(double)step/1000);
   }
   gotoxy(1,ty2); clrline(60);
   dds_send(7,0,0);/*DDS-OFF*/
}
/*======================
     α׷
=======================*/
void main(void)
{
char key;
int gdrv,gmod,i,ry;
long fq,step,ad;
double dd,dd2;

   /*׷ ̹ о̱*/
   gdrv=DETECT;
   initgraph(&gdrv,&gmod,"");
   if(graphresult()<0) {
      puts("Graphics error!");
      exit(1);
   }

   /*ʱȭ*/
   pinit();
   pmode(POUTPUT);
   gotoxy(1,1); puts(" Ʈũ ֳζ");
   screen();
   adc_init();
   gotoxy(1,ty9); puts(" 10Hz       100Hz        1KHz        10KHz       100KHz        1MHz       10MHz");
   /*̵溸,  ĵ  ʱȭ*/
   min_lim=0;
   for(i=0;i<640;i++) max_lim[i]=FULSCAL;

   /*Ŀǵ ó*/
   for(;;) {
      gotoxy(1,ty0); printf("Ŀǵ Է(ESC,Cal,Offset,Sweep,Tone) :");
      key=getch();
      gotoxy(1,ty0); clrline(60);
      if(key==27) break;/**/
      if(key=='s') {
         gotoxy(1,ty1); printf("ļƯ ");
         screen();  /*ǥ*/
         zerov(1);  /* ĵ*/
         graph(1,3);/*Ư */
         gotoxy(1,ty1); clrline(15);
      }
      if(key=='c') {
         gotoxy(1,ty1); printf("ļ Ư ");
         screen();    /*ǥ*/
         zerov(1);    /* ĵ*/
         graph(0,100);/*Ư */
         screen();    /* ǥ*/
         graph(2,0);  /*ü Ư ǥ*/
         gotoxy(1,ty1); clrline(15);
      }
      if(key=='t') {
         gotoxy(1,ty1); printf(" ļƯ ");
         printf("(ļ up='%c' down='%c'  up='%c' down='%c' ='ESC')",KEY_RIGHT,KEY_LEFT,KEY_UP,KEY_
DOWN);
         tone();
         gotoxy(1,ty1); clrline(80);
      }
      if(key=='o') {
         gotoxy(1,ty1); printf(" ǥ");
         zerov(0);
         gotoxy(1,ty1); clrline(20);
      }
   }
   pend();
   closegraph();
}
