;
; ţңϣ͡ңϣ ķ  α׷
;
; 1999.10.5 (R0.3)  IBM PC, NEC PC98 ڵ 
;

include stddef.inc
include str.inc
include file.inc
include ibmpc.inc

;----------------------------------------------------------------------------;
;   ޽ ũ 

.model t
.data

UsgMsg      db 'EROM - ROM emurator controler  1996.8.6',CR,LF,LF
      db 'Download >erom 64|128|256 <hex file> [<hex file>]...',CR,LF
      db 'Go|Reset >erom g|r',CR,LF,LF
      db 'Machine type = $'
MachineIBM db 'IBM PC',CR,LF,'$'
MachineNEC db 'NEC PC98',CR,LF,'$'
ErrMsg1    db 'Hex file data error.',CR,LF,'$'

RomType    dw ?           ; ROM type 16/32/64/128/256
PrevData db ?             ;  ͣ 룩
CtrlPort dw ?             ; Ʈ 巹
                     ; bit0: DATA  Ʈ Ʈ Ҵ
                     ; bit1: CLK
                     ; bit2: STB
                     ; bit3: PROG

Hand     dw ?             ;  ڵ
ReadPtr    dw ?           ; о 
ReadBuff db 512 dup(?)    ; о 

DataBuff db 32768 dup(?) ;  

Argc     db ?
Argv     dw ?,?,?


;----------------------------------------------------------------------------;
; α׷ 

.code
.186
      DEF_PSP

start:
      FIL_STR  <ofs DataBuff>,<size DataBuff>,0ffh
      GET_CMD_PAR  Argc,Argv

       call GET_PORT      ;  Ʈ 巹 

   _case e, Argc,0
      jmp   ivd_cmd

   _case e, Argc,1        ; 
      mov   bx,Argv[0]
      mov   al,[bx]
      CAPS al
    _if e, al,'R'         ; 
     outb   CtrlPort,1000b
    _else
     _if e, al,'G'        ;  
     outb   CtrlPort,0000b
     _else
      jmp   ivd_cmd
    __endif

   _case ae, Argc,2          ;  
      mov   bx,Argv[0]       ; set ROM type
       call GET_VAL
      mov   RomType,ax
      mov   bx,2
    _while ae, Argc,2
      OPEN_FILE  0,Argv[bx] ; open hex file
      jc dos_err
      mov   Hand,ax
      push bx
       call LOAD_DATA        ; load hex file
      CLOSE_FILE Hand
      pop   bx
      dec   Argc
     incw   bx
    _rept
       call SEND_DATA        ; send to EROM
   _endc
      $DOS  4ch,0


ivd_cmd: PRINT  UsgMsg       ; Ķ    ǥ
   _if e, CtrlPort, 40h
      PRINT  MachineNEC
   _else
      PRINT  MachineIBM
   _endif
      $DOS  4ch,0ffh

dos_err: ERR_OUT             ; DOS 
      $DOS  4ch

data_err:  PRINT  ErrMsg1   ; ȿ HEX 
      $DOS  4ch,0ffh

      GET_VAL_F              ; ġ ƾ 


GET_PORT proc                   ; Ʈ 巹 
      movseg   es,SEG_BIOS
      mov   ax,es:BiosLptLst[0] ; LPT1 巹 
      movseg   es,cs
   _skip e, ax,3bch             ; 3bc/378/278 ܴ̿ 98 Ǵ
    _skip e, ax,378h
     _skip e, ax,278h
      mov   ax,40h
   ___endif
      mov   CtrlPort,ax
      ret
GET_PORT endp


SEND_DATA  proc
      outb CtrlPort,0000b    ; īͿ Ʈ ʱȭ
      outb CtrlPort,1000b
      mov   PrevData,-1
      mov   al,0
       call SEND_BYTE
            ; 巹  ũ
   _case e, RomType,64
      mov   si,1fffh
   _case e, RomType,128
      mov   si,3fffh
   _case e, RomType,256
      mov   si,7fffh
   _default
      jmp   ivd_cmd
   _endc

      clr   bx                ;  
   _repeat 32768
      mov   ah,DataBuff[bx]
      inc   bx
      and   bx,si
       call SEND_BYTE
   _loop
      ret
SEND_DATA  endp


SEND_BYTE  proc              ; Ʈ  ah 
      mov   dx,CtrlPort
   _skip e, ah,PrevData      ;  
      mov   PrevData,ah
      push cx
    _repeat 8                ; send data to shift register
      mov   al,0100b
      rol   ah,1
      rcl   al,1
      out   dx,al
      set   al,BIT1
      out   dx,al
    _loop
      pop   cx
   _endif
      mov   al,1100b ; strobe
      out   dx,al
      mov   al,1000b
      out   dx,al
      ret
SEND_BYTE  endp


LOAD_DATA  proc              ;  ȣţ  о̱
      mov   ReadPtr,0
   _repeat
    _repeat                  ; skip pad
       call READ_CHR
      ret  e, al,EOF
    _rept ne, al,':'
      clr   dl                ; dl:check sum reg.
       call get_val          ; number of data
      mov   cl,al
       call get_val          ; address
      mov   bh,al
       call get_val
      mov   bl,al
       call get_val          ; record type
      mov   dh,al
    _repeat ne, cl,0         ; data
       call get_val
     _skip ae, bx,<size DataBuff>
      mov   DataBuff[bx],al
      inc   bx
     _endif
      dec   cl
    _rept
       call get_val          ; check sum
      cmp   dl,0
      jne   data_err
   _rept ne, dl,1
      ret

get_val:  call READ_CHR ;Ʈ 
      sub   al,'0'
      cmp   al,9
   @if a, <sub al,7>
      cmp   al,15
      ja data_err
      shl   al,4
      mov   ah,al
       call READ_CHR
      sub   al,'0'
      cmp   al,9
   @if a, <sub al,7>
      cmp   al,15
      ja data_err
      add   al,ah
      add   dl,al
      ret
LOAD_DATA  endp


READ_CHR proc                ; Ͽ  о̱
      push bx,cx,dx,ax
   _if e, ReadPtr,0
      READ_FILE Hand,<ofs ReadBuff>,<size ReadBuff>
      jc dos_err
    _if ne, ax,cx
      mov   bx,ax
      mov   ReadBuff[bx],EOF
   __endif
      pop   ax
      mov   bx,ReadPtr
      mov   al,ReadBuff[bx]
      inc   bx
      cmp   bx,size ReadBuff
   @if ae,<clr bx>
      mov   ReadPtr,bx
      pop   dx,cx,bx
      ret
READ_CHR endp

      $end start
